procedure OpCodeCB; assembler;
asm
    xor  eax, eax
    mov  bx, word ptr esi[PCREG]
    call GetByte
    inc  word ptr esi[PCREG]
    and  eax, $FFFF

    { Update tick counter }
    mov  ebx, eax
    xor  cx, cx
    mov  cl, byte ptr oCyclesCB[ebx]
    add  word ptr esi[TICKCOUNT], cx

    shl  eax, 3
    mov  ebx, offset @RLC_B
    add  eax, ebx
    jmp  eax
  @RLC_B:
    nop
    nop
    jmp  @RLC_B_Func
    nop

  @RLC_C:
    nop
    nop
    jmp  @RLC_C_Func
    nop

  @RLC_D:
    nop
    nop
    jmp  @RLC_D_Func
    nop

  @RLC_E:
    nop
    nop
    jmp  @RLC_E_Func
    nop

  @RLC_H:
    nop
    nop
    jmp  @RLC_H_Func
    nop

  @RLC_L:
    nop
    nop
    jmp  @RLC_L_Func
    nop

  @RLC_xHL:
    nop
    nop
    jmp  @RLC_xHL_Func
    nop

  @RLC_A:
    nop
    nop
    jmp  @RLC_A_Func
    nop

  @RRC_B:
    nop
    nop
    jmp  @RRC_B_Func
    nop

  @RRC_C:
    nop
    nop
    jmp  @RRC_C_Func
    nop

  @RRC_D:
    nop
    nop
    jmp  @RRC_D_Func
    nop

  @RRC_E:
    nop
    nop
    jmp  @RRC_E_Func
    nop

  @RRC_H:
    nop
    nop
    jmp  @RRC_H_Func
    nop

  @RRC_L:
    nop
    nop
    jmp  @RRC_L_Func
    nop

  @RRC_xHL:
    nop
    nop
    jmp  @RRC_xHL_Func
    nop

  @RRC_A:
    nop
    nop
    jmp  @RRC_A_Func
    nop

  @RL_B:
    nop
    nop
    jmp  @RL_B_Func
    nop

  @RL_C:
    nop
    nop
    jmp  @RL_C_Func
    nop

  @RL_D:
    nop
    nop
    jmp  @RL_D_Func
    nop

  @RL_E:
    nop
    nop
    jmp  @RL_E_Func
    nop

  @RL_H:
    nop
    nop
    jmp  @RL_H_Func
    nop

  @RL_L:
    nop
    nop
    jmp  @RL_L_Func
    nop

  @RL_xHL:
    nop
    nop
    jmp  @RL_xHL_Func
    nop

  @RL_A:
    nop
    nop
    jmp  @RL_A_Func
    nop

  @RR_B:
    nop
    nop
    jmp  @RR_B_Func
    nop

  @RR_C:
    nop
    nop
    jmp  @RR_C_Func
    nop

  @RR_D:
    nop
    nop
    jmp  @RR_D_Func
    nop

  @RR_E:
    nop
    nop
    jmp  @RR_E_Func
    nop

  @RR_H:
    nop
    nop
    jmp  @RR_H_Func
    nop

  @RR_L:
    nop
    nop
    jmp  @RR_L_Func
    nop

  @RR_xHL:
    nop
    nop
    jmp  @RR_xHL_Func
    nop

  @RR_A:
    nop
    nop
    jmp  @RR_A_Func
    nop

  @SLA_B:
    nop
    nop
    jmp  @SLA_B_Func
    nop

  @SLA_C:
    nop
    nop
    jmp  @SLA_C_Func
    nop

  @SLA_D:
    nop
    nop
    jmp  @SLA_D_Func
    nop

  @SLA_E:
    nop
    nop
    jmp  @SLA_E_Func
    nop

  @SLA_H:
    nop
    nop
    jmp  @SLA_H_Func
    nop

  @SLA_L:
    nop
    nop
    jmp  @SLA_L_Func
    nop

  @SLA_xHL:
    nop
    nop
    jmp  @SLA_xHL_Func
    nop

  @SLA_A:
    nop
    nop
    jmp  @SLA_A_Func
    nop

  @SRA_B:
    nop
    nop
    jmp  @SRA_B_Func
    nop

  @SRA_C:
    nop
    nop
    jmp  @SRA_C_Func
    nop

  @SRA_D:
    nop
    nop
    jmp  @SRA_D_Func
    nop

  @SRA_E:
    nop
    nop
    jmp  @SRA_E_Func
    nop

  @SRA_H:
    nop
    nop
    jmp  @SRA_H_Func
    nop

  @SRA_L:
    nop
    nop
    jmp  @SRA_L_Func
    nop

  @SRA_xHL:
    nop
    nop
    jmp  @SRA_xHL_Func
    nop

  @SRA_A:
    nop
    nop
    jmp  @SRA_A_Func
    nop

  @SLL_B:
    nop
    nop
    jmp  @SLL_B_Func
    nop

  @SLL_C:
    nop
    nop
    jmp  @SLL_C_Func
    nop

  @SLL_D:
    nop
    nop
    jmp  @SLL_D_Func
    nop

  @SLL_E:
    nop
    nop
    jmp  @SLL_E_Func
    nop

  @SLL_H:
    nop
    nop
    jmp  @SLL_H_Func
    nop

  @SLL_L:
    nop
    nop
    jmp  @SLL_L_Func
    nop

  @SLL_xHL:
    nop
    nop
    jmp  @SLL_xHL_Func
    nop

  @SLL_A:
    nop
    nop
    jmp  @SLL_A_Func
    nop

  @SRL_B:
    nop
    nop
    jmp  @SRL_B_Func
    nop

  @SRL_C:
    nop
    nop
    jmp  @SRL_C_Func
    nop

  @SRL_D:
    nop
    nop
    jmp  @SRL_D_Func
    nop

  @SRL_E:
    nop
    nop
    jmp  @SRL_E_Func
    nop

  @SRL_H:
    nop
    nop
    jmp  @SRL_H_Func
    nop

  @SRL_L:
    nop
    nop
    jmp  @SRL_L_Func
    nop

  @SRL_xHL:
    nop
    nop
    jmp  @SRL_xHL_Func
    nop

  @SRL_A:
    nop
    nop
    jmp  @SRL_A_Func
    nop

  @BIT0_B:
    nop
    nop
    jmp  @BIT0_B_Func
    nop

  @BIT0_C:
    nop
    nop
    jmp  @BIT0_C_Func
    nop

  @BIT0_D:
    nop
    nop
    jmp  @BIT0_D_Func
    nop

  @BIT0_E:
    nop
    nop
    jmp  @BIT0_E_Func
    nop

  @BIT0_H:
    nop
    nop
    jmp  @BIT0_H_Func
    nop

  @BIT0_L:
    nop
    nop
    jmp  @BIT0_L_Func
    nop

  @BIT0_xHL:
    nop
    nop
    jmp  @BIT0_xHL_Func
    nop

  @BIT0_A:
    nop
    nop
    jmp  @BIT0_A_Func
    nop

  @BIT1_B:
    nop
    nop
    jmp  @BIT1_B_Func
    nop

  @BIT1_C:
    nop
    nop
    jmp  @BIT1_C_Func
    nop

  @BIT1_D:
    nop
    nop
    jmp  @BIT1_D_Func
    nop

  @BIT1_E:
    nop
    nop
    jmp  @BIT1_E_Func
    nop

  @BIT1_H:
    nop
    nop
    jmp  @BIT1_H_Func
    nop

  @BIT1_L:
    nop
    nop
    jmp  @BIT1_L_Func
    nop

  @BIT1_xHL:
    nop
    nop
    jmp  @BIT1_xHL_Func
    nop

  @BIT1_A:
    nop
    nop
    jmp  @BIT1_A_Func
    nop

  @BIT2_B:
    nop
    nop
    jmp  @BIT2_B_Func
    nop

  @BIT2_C:
    nop
    nop
    jmp  @BIT2_C_Func
    nop

  @BIT2_D:
    nop
    nop
    jmp  @BIT2_D_Func
    nop

  @BIT2_E:
    nop
    nop
    jmp  @BIT2_E_Func
    nop

  @BIT2_H:
    nop
    nop
    jmp  @BIT2_H_Func
    nop

  @BIT2_L:
    nop
    nop
    jmp  @BIT2_L_Func
    nop

  @BIT2_xHL:
    nop
    nop
    jmp  @BIT2_xHL_Func
    nop

  @BIT2_A:
    nop
    nop
    jmp  @BIT2_A_Func
    nop

  @BIT3_B:
    nop
    nop
    jmp  @BIT3_B_Func
    nop

  @BIT3_C:
    nop
    nop
    jmp  @BIT3_C_Func
    nop

  @BIT3_D:
    nop
    nop
    jmp  @BIT3_D_Func
    nop

  @BIT3_E:
    nop
    nop
    jmp  @BIT3_E_Func
    nop

  @BIT3_H:
    nop
    nop
    jmp  @BIT3_H_Func
    nop

  @BIT3_L:
    nop
    nop
    jmp  @BIT3_L_Func
    nop

  @BIT3_xHL:
    nop
    nop
    jmp  @BIT3_xHL_Func
    nop

  @BIT3_A:
    nop
    nop
    jmp  @BIT3_A_Func
    nop

  @BIT4_B:
    nop
    nop
    jmp  @BIT4_B_Func
    nop

  @BIT4_C:
    nop
    nop
    jmp  @BIT4_C_Func
    nop

  @BIT4_D:
    nop
    nop
    jmp  @BIT4_D_Func
    nop

  @BIT4_E:
    nop
    nop
    jmp  @BIT4_E_Func
    nop

  @BIT4_H:
    nop
    nop
    jmp  @BIT4_H_Func
    nop

  @BIT4_L:
    nop
    nop
    jmp  @BIT4_L_Func
    nop

  @BIT4_xHL:
    nop
    nop
    jmp  @BIT4_xHL_Func
    nop

  @BIT4_A:
    nop
    nop
    jmp  @BIT4_A_Func
    nop

  @BIT5_B:
    nop
    nop
    jmp  @BIT5_B_Func
    nop

  @BIT5_C:
    nop
    nop
    jmp  @BIT5_C_Func
    nop

  @BIT5_D:
    nop
    nop
    jmp  @BIT5_D_Func
    nop

  @BIT5_E:
    nop
    nop
    jmp  @BIT5_E_Func
    nop

  @BIT5_H:
    nop
    nop
    jmp  @BIT5_H_Func
    nop

  @BIT5_L:
    nop
    nop
    jmp  @BIT5_L_Func
    nop

  @BIT5_xHL:
    nop
    nop
    jmp  @BIT5_xHL_Func
    nop

  @BIT5_A:
    nop
    nop
    jmp  @BIT5_A_Func
    nop

  @BIT6_B:
    nop
    nop
    jmp  @BIT6_B_Func
    nop

  @BIT6_C:
    nop
    nop
    jmp  @BIT6_C_Func
    nop

  @BIT6_D:
    nop
    nop
    jmp  @BIT6_D_Func
    nop

  @BIT6_E:
    nop
    nop
    jmp  @BIT6_E_Func
    nop

  @BIT6_H:
    nop
    nop
    jmp  @BIT6_H_Func
    nop

  @BIT6_L:
    nop
    nop
    jmp  @BIT6_L_Func
    nop

  @BIT6_xHL:
    nop
    nop
    jmp  @BIT6_xHL_Func
    nop

  @BIT6_A:
    nop
    nop
    jmp  @BIT6_A_Func
    nop

  @BIT7_B:
    nop
    nop
    jmp  @BIT7_B_Func
    nop

  @BIT7_C:
    nop
    nop
    jmp  @BIT7_C_Func
    nop

  @BIT7_D:
    nop
    nop
    jmp  @BIT7_D_Func
    nop

  @BIT7_E:
    nop
    nop
    jmp  @BIT7_E_Func
    nop

  @BIT7_H:
    nop
    nop
    jmp  @BIT7_H_Func
    nop

  @BIT7_L:
    nop
    nop
    jmp  @BIT7_L_Func
    nop

  @BIT7_xHL:
    nop
    nop
    jmp  @BIT7_xHL_Func
    nop

  @BIT7_A:
    nop
    nop
    jmp  @BIT7_A_Func
    nop

  @RES0_B:
    nop
    nop
    jmp  @RES0_B_Func
    nop

  @RES0_C:
    nop
    nop
    jmp  @RES0_C_Func
    nop

  @RES0_D:
    nop
    nop
    jmp  @RES0_D_Func
    nop

  @RES0_E:
    nop
    nop
    jmp  @RES0_E_Func
    nop

  @RES0_H:
    nop
    nop
    jmp  @RES0_H_Func
    nop

  @RES0_L:
    nop
    nop
    jmp  @RES0_L_Func
    nop

  @RES0_xHL:
    nop
    nop
    jmp  @RES0_xHL_Func
    nop

  @RES0_A:
    nop
    nop
    jmp  @RES0_A_Func
    nop

  @RES1_B:
    nop
    nop
    jmp  @RES1_B_Func
    nop

  @RES1_C:
    nop
    nop
    jmp  @RES1_C_Func
    nop

  @RES1_D:
    nop
    nop
    jmp  @RES1_D_Func
    nop

  @RES1_E:
    nop
    nop
    jmp  @RES1_E_Func
    nop

  @RES1_H:
    nop
    nop
    jmp  @RES1_H_Func
    nop

  @RES1_L:
    nop
    nop
    jmp  @RES1_L_Func
    nop

  @RES1_xHL:
    nop
    nop
    jmp  @RES1_xHL_Func
    nop

  @RES1_A:
    nop
    nop
    jmp  @RES1_A_Func
    nop

  @RES2_B:
    nop
    nop
    jmp  @RES2_B_Func
    nop

  @RES2_C:
    nop
    nop
    jmp  @RES2_C_Func
    nop

  @RES2_D:
    nop
    nop
    jmp  @RES2_D_Func
    nop

  @RES2_E:
    nop
    nop
    jmp  @RES2_E_Func
    nop

  @RES2_H:
    nop
    nop
    jmp  @RES2_H_Func
    nop

  @RES2_L:
    nop
    nop
    jmp  @RES2_L_Func
    nop

  @RES2_xHL:
    nop
    nop
    jmp  @RES2_xHL_Func
    nop

  @RES2_A:
    nop
    nop
    jmp  @RES2_A_Func
    nop

  @RES3_B:
    nop
    nop
    jmp  @RES3_B_Func
    nop

  @RES3_C:
    nop
    nop
    jmp  @RES3_C_Func
    nop

  @RES3_D:
    nop
    nop
    jmp  @RES3_D_Func
    nop

  @RES3_E:
    nop
    nop
    jmp  @RES3_E_Func
    nop

  @RES3_H:
    nop
    nop
    jmp  @RES3_H_Func
    nop

  @RES3_L:
    nop
    nop
    jmp  @RES3_L_Func
    nop

  @RES3_xHL:
    nop
    nop
    jmp  @RES3_xHL_Func
    nop

  @RES3_A:
    nop
    nop
    jmp  @RES3_A_Func
    nop

  @RES4_B:
    nop
    nop
    jmp  @RES4_B_Func
    nop

  @RES4_C:
    nop
    nop
    jmp  @RES4_C_Func
    nop

  @RES4_D:
    nop
    nop
    jmp  @RES4_D_Func
    nop

  @RES4_E:
    nop
    nop
    jmp  @RES4_E_Func
    nop

  @RES4_H:
    nop
    nop
    jmp  @RES4_H_Func
    nop

  @RES4_L:
    nop
    nop
    jmp  @RES4_L_Func
    nop

  @RES4_xHL:
    nop
    nop
    jmp  @RES4_xHL_Func
    nop

  @RES4_A:
    nop
    nop
    jmp  @RES4_A_Func
    nop

  @RES5_B:
    nop
    nop
    jmp  @RES5_B_Func
    nop

  @RES5_C:
    nop
    nop
    jmp  @RES5_C_Func
    nop

  @RES5_D:
    nop
    nop
    jmp  @RES5_D_Func
    nop

  @RES5_E:
    nop
    nop
    jmp  @RES5_E_Func
    nop

  @RES5_H:
    nop
    nop
    jmp  @RES5_H_Func
    nop

  @RES5_L:
    nop
    nop
    jmp  @RES5_L_Func
    nop

  @RES5_xHL:
    nop
    nop
    jmp  @RES5_xHL_Func
    nop

  @RES5_A:
    nop
    nop
    jmp  @RES5_A_Func
    nop

  @RES6_B:
    nop
    nop
    jmp  @RES6_B_Func
    nop

  @RES6_C:
    nop
    nop
    jmp  @RES6_C_Func
    nop

  @RES6_D:
    nop
    nop
    jmp  @RES6_D_Func
    nop

  @RES6_E:
    nop
    nop
    jmp  @RES6_E_Func
    nop

  @RES6_H:
    nop
    nop
    jmp  @RES6_H_Func
    nop

  @RES6_L:
    nop
    nop
    jmp  @RES6_L_Func
    nop

  @RES6_xHL:
    nop
    nop
    jmp  @RES6_xHL_Func
    nop

  @RES6_A:
    nop
    nop
    jmp  @RES6_A_Func
    nop

  @RES7_B:
    nop
    nop
    jmp  @RES7_B_Func
    nop

  @RES7_C:
    nop
    nop
    jmp  @RES7_C_Func
    nop

  @RES7_D:
    nop
    nop
    jmp  @RES7_D_Func
    nop

  @RES7_E:
    nop
    nop
    jmp  @RES7_E_Func
    nop

  @RES7_H:
    nop
    nop
    jmp  @RES7_H_Func
    nop

  @RES7_L:
    nop
    nop
    jmp  @RES7_L_Func
    nop

  @RES7_xHL:
    nop
    nop
    jmp  @RES7_xHL_Func
    nop

  @RES7_A:
    nop
    nop
    jmp  @RES7_A_Func
    nop

  @SET0_B:
    nop
    nop
    jmp  @SET0_B_Func
    nop

  @SET0_C:
    nop
    nop
    jmp  @SET0_C_Func
    nop

  @SET0_D:
    nop
    nop
    jmp  @SET0_D_Func
    nop

  @SET0_E:
    nop
    nop
    jmp  @SET0_E_Func
    nop

  @SET0_H:
    nop
    nop
    jmp  @SET0_H_Func
    nop

  @SET0_L:
    nop
    nop
    jmp  @SET0_L_Func
    nop

  @SET0_xHL:
    nop
    nop
    jmp  @SET0_xHL_Func
    nop

  @SET0_A:
    nop
    nop
    jmp  @SET0_A_Func
    nop

  @SET1_B:
    nop
    nop
    jmp  @SET1_B_Func
    nop

  @SET1_C:
    nop
    nop
    jmp  @SET1_C_Func
    nop

  @SET1_D:
    nop
    nop
    jmp  @SET1_D_Func
    nop

  @SET1_E:
    nop
    nop
    jmp  @SET1_E_Func
    nop

  @SET1_H:
    nop
    nop
    jmp  @SET1_H_Func
    nop

  @SET1_L:
    nop
    nop
    jmp  @SET1_L_Func
    nop

  @SET1_xHL:
    nop
    nop
    jmp  @SET1_xHL_Func
    nop

  @SET1_A:
    nop
    nop
    jmp  @SET1_A_Func
    nop

  @SET2_B:
    nop
    nop
    jmp  @SET2_B_Func
    nop

  @SET2_C:
    nop
    nop
    jmp  @SET2_C_Func
    nop

  @SET2_D:
    nop
    nop
    jmp  @SET2_D_Func
    nop

  @SET2_E:
    nop
    nop
    jmp  @SET2_E_Func
    nop

  @SET2_H:
    nop
    nop
    jmp  @SET2_H_Func
    nop

  @SET2_L:
    nop
    nop
    jmp  @SET2_L_Func
    nop

  @SET2_xHL:
    nop
    nop
    jmp  @SET2_xHL_Func
    nop

  @SET2_A:
    nop
    nop
    jmp  @SET2_A_Func
    nop

  @SET3_B:
    nop
    nop
    jmp  @SET3_B_Func
    nop

  @SET3_C:
    nop
    nop
    jmp  @SET3_C_Func
    nop

  @SET3_D:
    nop
    nop
    jmp  @SET3_D_Func
    nop

  @SET3_E:
    nop
    nop
    jmp  @SET3_E_Func
    nop

  @SET3_H:
    nop
    nop
    jmp  @SET3_H_Func
    nop

  @SET3_L:
    nop
    nop
    jmp  @SET3_L_Func
    nop

  @SET3_xHL:
    nop
    nop
    jmp  @SET3_xHL_Func
    nop

  @SET3_A:
    nop
    nop
    jmp  @SET3_A_Func
    nop

  @SET4_B:
    nop
    nop
    jmp  @SET4_B_Func
    nop

  @SET4_C:
    nop
    nop
    jmp  @SET4_C_Func
    nop

  @SET4_D:
    nop
    nop
    jmp  @SET4_D_Func
    nop

  @SET4_E:
    nop
    nop
    jmp  @SET4_E_Func
    nop

  @SET4_H:
    nop
    nop
    jmp  @SET4_H_Func
    nop

  @SET4_L:
    nop
    nop
    jmp  @SET4_L_Func
    nop

  @SET4_xHL:
    nop
    nop
    jmp  @SET4_xHL_Func
    nop

  @SET4_A:
    nop
    nop
    jmp  @SET4_A_Func
    nop

  @SET5_B:
    nop
    nop
    jmp  @SET5_B_Func
    nop

  @SET5_C:
    nop
    nop
    jmp  @SET5_C_Func
    nop

  @SET5_D:
    nop
    nop
    jmp  @SET5_D_Func
    nop

  @SET5_E:
    nop
    nop
    jmp  @SET5_E_Func
    nop

  @SET5_H:
    nop
    nop
    jmp  @SET5_H_Func
    nop

  @SET5_L:
    nop
    nop
    jmp  @SET5_L_Func
    nop

  @SET5_xHL:
    nop
    nop
    jmp  @SET5_xHL_Func
    nop

  @SET5_A:
    nop
    nop
    jmp  @SET5_A_Func
    nop

  @SET6_B:
    nop
    nop
    jmp  @SET6_B_Func
    nop

  @SET6_C:
    nop
    nop
    jmp  @SET6_C_Func
    nop

  @SET6_D:
    nop
    nop
    jmp  @SET6_D_Func
    nop

  @SET6_E:
    nop
    nop
    jmp  @SET6_E_Func
    nop

  @SET6_H:
    nop
    nop
    jmp  @SET6_H_Func
    nop

  @SET6_L:
    nop
    nop
    jmp  @SET6_L_Func
    nop

  @SET6_xHL:
    nop
    nop
    jmp  @SET6_xHL_Func
    nop

  @SET6_A:
    nop
    nop
    jmp  @SET6_A_Func
    nop

  @SET7_B:
    nop
    nop
    jmp  @SET7_B_Func
    nop

  @SET7_C:
    nop
    nop
    jmp  @SET7_C_Func
    nop

  @SET7_D:
    nop
    nop
    jmp  @SET7_D_Func
    nop

  @SET7_E:
    nop
    nop
    jmp  @SET7_E_Func
    nop

  @SET7_H:
    nop
    nop
    jmp  @SET7_H_Func
    nop

  @SET7_L:
    nop
    nop
    jmp  @SET7_L_Func
    nop

  @SET7_xHL:
    nop
    nop
    jmp  @SET7_xHL_Func
    nop

  @SET7_A:
    nop
    nop
    jmp  @SET7_A_Func
    nop

  @RLC_B_Func:
    rol  byte ptr esi[BREG], 1
    lahf
    and  ah, 00000001b
    mov  al, ah
    mov  ah, byte ptr esi[BREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr esi[FREG], ah
    jmp  @Exit

  @RLC_C_Func:
    rol  byte ptr esi[CREG], 1
    lahf
    and  ah, 00000001b
    mov  al, ah
    mov  ah, byte ptr esi[CREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr esi[FREG], ah
    jmp  @Exit

  @RLC_D_Func:
    rol  byte ptr esi[DREG], 1
    lahf
    and  ah, 00000001b
    mov  al, ah
    mov  ah, byte ptr esi[DREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr esi[FREG], ah
    jmp  @Exit

  @RLC_E_Func:
    rol  byte ptr esi[EREG], 1
    lahf
    and  ah, 00000001b
    mov  al, ah
    mov  ah, byte ptr esi[EREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr esi[FREG], ah
    jmp  @Exit

  @RLC_H_Func:
    rol  byte ptr esi[HREG], 1
    lahf
    and  ah, 00000001b
    mov  al, ah
    mov  ah, byte ptr esi[HREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr esi[FREG], ah
    jmp  @Exit

  @RLC_L_Func:
    rol  byte ptr esi[LREG], 1
    lahf
    and  ah, 00000001b
    mov  al, ah
    mov  ah, byte ptr esi[LREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr esi[FREG], ah
    jmp  @Exit

  @RLC_xHL_Func:
    mov  bx, word ptr esi[HLREG]
    call GetByte
    mov  dl, al
    rol  dl, 1
    lahf
    and  ah, 00000001b
    mov  al, ah
    mov  ah, dl
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr esi[FREG], ah
    mov  al, dl
    call PutByte
    jmp  @Exit

  @RLC_A_Func:
    rol  byte ptr esi[AREG], 1
    lahf
    and  ah, 00000001b
    mov  al, ah
    mov  ah, byte ptr esi[AREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr esi[FREG], ah
    jmp  @Exit

  @RRC_B_Func:
    ror  byte ptr esi[BREG], 1
    lahf
    and  ah, 00000001b
    mov  al, ah
    mov  ah, byte ptr esi[BREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr esi[FREG], ah
    jmp  @Exit

  @RRC_C_Func:
    ror  byte ptr esi[CREG], 1
    lahf
    and  ah, 00000001b
    mov  al, ah
    mov  ah, byte ptr esi[CREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr esi[FREG], ah
    jmp  @Exit

  @RRC_D_Func:
    ror  byte ptr esi[DREG], 1
    lahf
    and  ah, 00000001b
    mov  al, ah
    mov  ah, byte ptr esi[DREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr esi[FREG], ah
    jmp  @Exit

  @RRC_E_Func:
    ror  byte ptr esi[EREG], 1
    lahf
    and  ah, 00000001b
    mov  al, ah
    mov  ah, byte ptr esi[EREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr esi[FREG], ah
    jmp  @Exit

  @RRC_H_Func:
    ror  byte ptr esi[HREG], 1
    lahf
    and  ah, 00000001b
    mov  al, ah
    mov  ah, byte ptr esi[HREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr esi[FREG], ah
    jmp  @Exit

  @RRC_L_Func:
    ror  byte ptr esi[LREG], 1
    lahf
    and  ah, 00000001b
    mov  al, ah
    mov  ah, byte ptr esi[LREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr esi[FREG], ah
    jmp  @Exit

  @RRC_xHL_Func:
    mov  bx, word ptr esi[HLREG]
    call GetByte
    mov  dl, al
    ror  dl, 1
    lahf
    and  ah, 00000001b
    mov  al, ah
    mov  ah, dl
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr esi[FREG], ah
    mov  al, dl
    call PutByte
    jmp  @Exit

  @RRC_A_Func:
    ror  byte ptr esi[AREG], 1
    lahf
    and  ah, 00000001b
    mov  al, ah
    mov  ah, byte ptr esi[AREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr esi[FREG], ah
    jmp  @Exit

  @RL_B_Func:
    ror  byte ptr esi[FREG], 1
    rcl  byte ptr esi[BREG], 1
    lahf
    and  ah, 00000001b
    mov  al, ah
    mov  ah, byte ptr esi[BREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr esi[FREG], ah
    jmp  @Exit

  @RL_C_Func:
    ror  byte ptr esi[FREG], 1
    rcl  byte ptr esi[CREG], 1
    lahf
    and  ah, 00000001b
    mov  al, ah
    mov  ah, byte ptr esi[CREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr esi[FREG], ah
    jmp  @Exit

  @RL_D_Func:
    ror  byte ptr esi[FREG], 1
    rcl  byte ptr esi[DREG], 1
    lahf
    and  ah, 00000001b
    mov  al, ah
    mov  ah, byte ptr esi[DREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr esi[FREG], ah
    jmp  @Exit

  @RL_E_Func:
    ror  byte ptr esi[FREG], 1
    rcl  byte ptr esi[EREG], 1
    lahf
    and  ah, 00000001b
    mov  al, ah
    mov  ah, byte ptr esi[EREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr esi[FREG], ah
    jmp  @Exit

  @RL_H_Func:
    ror  byte ptr esi[FREG], 1
    rcl  byte ptr esi[HREG], 1
    lahf
    and  ah, 00000001b
    mov  al, ah
    mov  ah, byte ptr esi[HREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr esi[FREG], ah
    jmp  @Exit

  @RL_L_Func:
    ror  byte ptr esi[FREG], 1
    rcl  byte ptr esi[LREG], 1
    lahf
    and  ah, 00000001b
    mov  al, ah
    mov  ah, byte ptr esi[LREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr esi[FREG], ah
    jmp  @Exit

  @RL_xHL_Func:
    mov  bx, word ptr esi[HLREG]
    call GetByte
    mov  dl, al
    ror  byte ptr esi[FREG], 1
    rcl  dl, 1
    lahf
    and  ah, 00000001b
    mov  al, ah
    mov  ah, dl
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr esi[FREG], ah
    mov  al, dl
    call PutByte
    jmp  @Exit

  @RL_A_Func:
    ror  byte ptr esi[FREG], 1
    rcl  byte ptr esi[AREG], 1
    lahf
    and  ah, 00000001b
    mov  al, ah
    mov  ah, byte ptr esi[AREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr esi[FREG], ah
    jmp  @Exit

  @RR_B_Func:
    ror  byte ptr esi[FREG], 1
    rcr  byte ptr esi[BREG], 1
    lahf
    and  ah, 00000001b
    mov  al, ah
    mov  ah, byte ptr esi[BREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr esi[FREG], ah
    jmp  @Exit

  @RR_C_Func:
    ror  byte ptr esi[FREG], 1
    rcr  byte ptr esi[CREG], 1
    lahf
    and  ah, 00000001b
    mov  al, ah
    mov  ah, byte ptr esi[CREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr esi[FREG], ah
    jmp  @Exit

  @RR_D_Func:
    ror  byte ptr esi[FREG], 1
    rcr  byte ptr esi[DREG], 1
    lahf
    and  ah, 00000001b
    mov  al, ah
    mov  ah, byte ptr esi[DREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr esi[FREG], ah
    jmp  @Exit

  @RR_E_Func:
    ror  byte ptr esi[FREG], 1
    rcr  byte ptr esi[EREG], 1
    lahf
    and  ah, 00000001b
    mov  al, ah
    mov  ah, byte ptr esi[EREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr esi[FREG], ah
    jmp  @Exit

  @RR_H_Func:
    ror  byte ptr esi[FREG], 1
    rcr  byte ptr esi[HREG], 1
    lahf
    and  ah, 00000001b
    mov  al, ah
    mov  ah, byte ptr esi[HREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr esi[FREG], ah
    jmp  @Exit

  @RR_L_Func:
    ror  byte ptr esi[FREG], 1
    rcr  byte ptr esi[LREG], 1
    lahf
    and  ah, 00000001b
    mov  al, ah
    mov  ah, byte ptr esi[LREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr esi[FREG], ah
    jmp  @Exit

  @RR_xHL_Func:
    mov  bx, word ptr esi[HLREG]
    call GetByte
    mov  dl, al
    ror  byte ptr esi[FREG], 1
    rcr  dl, 1
    lahf
    and  ah, 00000001b
    mov  al, ah
    mov  ah, dl
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr esi[FREG], ah
    mov  al, dl
    call PutByte
    jmp  @Exit

  @RR_A_Func:
    ror  byte ptr esi[FREG], 1
    rcr  byte ptr esi[AREG], 1
    lahf
    and  ah, 00000001b
    mov  al, ah
    mov  ah, byte ptr esi[AREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr esi[FREG], ah
    jmp  @Exit

  @SLA_B_Func:
    shl  byte ptr esi[BREG], 1
    lahf
    and  ah,00000001b
    mov  al, ah
    mov  ah, byte ptr esi[BREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr esi[FREG],ah
    jmp  @Exit

  @SLA_C_Func:
    shl  byte ptr esi[CREG], 1
    lahf
    and  ah,00000001b
    mov  al, ah
    mov  ah, byte ptr esi[CREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr esi[FREG],ah
    jmp  @Exit

  @SLA_D_Func:
    shl  byte ptr esi[DREG], 1
    lahf
    and  ah,00000001b
    mov  al, ah
    mov  ah, byte ptr esi[DREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr esi[FREG],ah
    jmp  @Exit

  @SLA_E_Func:
    shl  byte ptr esi[EREG], 1
    lahf
    and  ah,00000001b
    mov  al, ah
    mov  ah, byte ptr esi[EREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr esi[FREG],ah
    jmp  @Exit

  @SLA_H_Func:
    shl  byte ptr esi[HREG], 1
    lahf
    and  ah,00000001b
    mov  al, ah
    mov  ah, byte ptr esi[HREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr esi[FREG],ah
    jmp  @Exit

  @SLA_L_Func:
    shl  byte ptr esi[LREG], 1
    lahf
    and  ah,00000001b
    mov  al, ah
    mov  ah, byte ptr esi[LREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr esi[FREG],ah
    jmp  @Exit

  @SLA_xHL_Func:
    mov  bx, word ptr esi[HLREG]
    call GetByte
    mov  dl, al
    shl  dl, 1
    lahf
    and  ah,00000001b
    mov  al, ah
    mov  ah, dl
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr esi[FREG],ah
    mov  al, dl
    call PutByte
    jmp  @Exit

  @SLA_A_Func:
    shl  byte ptr esi[AREG], 1
    lahf
    and  ah,00000001b
    mov  al, ah
    mov  ah, byte ptr esi[AREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr esi[FREG],ah
    jmp  @Exit

  @SRA_B_Func:
    sar  byte ptr esi[BREG],1
    lahf
    and  ah,00000001b
    mov  al,ah
    mov  ah,byte ptr esi[BREG]
    and  ah,ah
    lahf
    and  ah,11101100b
    or   ah,al
    mov  byte ptr esi[FREG],ah
    jmp  @Exit

  @SRA_C_Func:
    sar  byte ptr esi[CREG],1
    lahf
    and  ah,00000001b
    mov  al,ah
    mov  ah,byte ptr esi[CREG]
    and  ah,ah
    lahf
    and  ah,11101100b
    or   ah,al
    mov  byte ptr esi[FREG],ah
    jmp  @Exit

  @SRA_D_Func:
    sar  byte ptr esi[DREG],1
    lahf
    and  ah,00000001b
    mov  al,ah
    mov  ah,byte ptr esi[DREG]
    and  ah,ah
    lahf
    and  ah,11101100b
    or   ah,al
    mov  byte ptr esi[FREG],ah
    jmp  @Exit

  @SRA_E_Func:
    sar  byte ptr esi[EREG],1
    lahf
    and  ah,00000001b
    mov  al,ah
    mov  ah,byte ptr esi[EREG]
    and  ah,ah
    lahf
    and  ah,11101100b
    or   ah,al
    mov  byte ptr esi[FREG],ah
    jmp  @Exit

  @SRA_H_Func:
    sar  byte ptr esi[HREG],1
    lahf
    and  ah,00000001b
    mov  al,ah
    mov  ah,byte ptr esi[HREG]
    and  ah,ah
    lahf
    and  ah,11101100b
    or   ah,al
    mov  byte ptr esi[FREG],ah
    jmp  @Exit

  @SRA_L_Func:
    sar  byte ptr esi[LREG],1
    lahf
    and  ah,00000001b
    mov  al,ah
    mov  ah,byte ptr esi[LREG]
    and  ah,ah
    lahf
    and  ah,11101100b
    or   ah,al
    mov  byte ptr esi[FREG],ah
    jmp  @Exit

  @SRA_xHL_Func:
    mov  bx, word ptr esi[HLREG]
    call GetByte
    mov  dl, al
    sar  dl,1
    lahf
    and  ah,00000001b
    mov  al,ah
    mov  ah,dl
    and  ah,ah
    lahf
    and  ah,11101100b
    or   ah,al
    mov  byte ptr esi[FREG],ah
    mov  al, dl
    call PutByte
    jmp  @Exit

  @SRA_A_Func:
    sar  byte ptr esi[AREG],1
    lahf
    and  ah,00000001b
    mov  al,ah
    mov  ah,byte ptr esi[AREG]
    and  ah,ah
    lahf
    and  ah,11101100b
    or   ah,al
    mov  byte ptr esi[FREG],ah
    jmp  @Exit

  @SLL_B_Func:
    stc
    rcl  byte ptr esi[BREG],1
    lahf
    and  ah, 00000001b
    mov  al, ah
    mov  ah, byte ptr esi[BREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr esi[FREG], ah
    jmp  @Exit

  @SLL_C_Func:
    stc
    rcl  byte ptr esi[CREG],1
    lahf
    and  ah, 00000001b
    mov  al, ah
    mov  ah, byte ptr esi[CREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr esi[FREG], ah
    jmp  @Exit

  @SLL_D_Func:
    stc
    rcl  byte ptr esi[DREG],1
    lahf
    and  ah, 00000001b
    mov  al, ah
    mov  ah, byte ptr esi[DREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr esi[FREG], ah
    jmp  @Exit

  @SLL_E_Func:
    stc
    rcl  byte ptr esi[EREG],1
    lahf
    and  ah, 00000001b
    mov  al, ah
    mov  ah, byte ptr esi[EREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr esi[FREG], ah
    jmp  @Exit

  @SLL_H_Func:
    stc
    rcl  byte ptr esi[HREG],1
    lahf
    and  ah, 00000001b
    mov  al, ah
    mov  ah, byte ptr esi[HREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr esi[FREG], ah
    jmp  @Exit

  @SLL_L_Func:
    stc
    rcl  byte ptr esi[LREG],1
    lahf
    and  ah, 00000001b
    mov  al, ah
    mov  ah, byte ptr esi[LREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr esi[FREG], ah
    jmp  @Exit

  @SLL_xHL_Func:
    mov  bx, word ptr esi[HLREG]
    call GetByte
    mov  dl, al
    stc
    rcl  dl,1
    lahf
    and  ah, 00000001b
    mov  al, ah
    mov  ah, dl
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr esi[FREG], ah
    mov  al, dl
    call PutByte
    jmp  @Exit

  @SLL_A_Func:
    stc
    rcl  byte ptr esi[AREG],1
    lahf
    and  ah, 00000001b
    mov  al, ah
    mov  ah, byte ptr esi[AREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr esi[FREG], ah
    jmp  @Exit

  @SRL_B_Func:
    shr  byte ptr esi[BREG], 1
    lahf
    and  ah, 00000001b
    mov  al, ah
    mov  ah,byte ptr esi[BREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr esi[FREG],ah
    jmp  @Exit

  @SRL_C_Func:
    shr  byte ptr esi[CREG], 1
    lahf
    and  ah, 00000001b
    mov  al, ah
    mov  ah,byte ptr esi[CREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr esi[FREG],ah
    jmp  @Exit

  @SRL_D_Func:
    shr  byte ptr esi[DREG], 1
    lahf
    and  ah, 00000001b
    mov  al, ah
    mov  ah,byte ptr esi[DREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr esi[FREG],ah
    jmp  @Exit

  @SRL_E_Func:
    shr  byte ptr esi[EREG], 1
    lahf
    and  ah, 00000001b
    mov  al, ah
    mov  ah,byte ptr esi[EREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr esi[FREG],ah
    jmp  @Exit

  @SRL_H_Func:
    shr  byte ptr esi[HREG], 1
    lahf
    and  ah, 00000001b
    mov  al, ah
    mov  ah,byte ptr esi[HREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr esi[FREG],ah
    jmp  @Exit

  @SRL_L_Func:
    shr  byte ptr esi[LREG], 1
    lahf
    and  ah, 00000001b
    mov  al, ah
    mov  ah,byte ptr esi[LREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr esi[FREG],ah
    jmp  @Exit

  @SRL_xHL_Func:
    mov  bx, word ptr esi[HLREG]
    call GetByte
    mov  dl, al
    shr  dl, 1
    lahf
    and  ah, 00000001b
    mov  al, ah
    mov  ah,dl
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr esi[FREG],ah
    mov  al, dl
    call PutByte
    jmp  @Exit

  @SRL_A_Func:
    shr  byte ptr esi[AREG], 1
    lahf
    and  ah, 00000001b
    mov  al, ah
    mov  ah,byte ptr esi[AREG]
    and  ah, ah
    lahf
    and  ah, 11101100b
    or   ah, al
    mov  byte ptr esi[FREG],ah
    jmp  @Exit

  @BIT0_B_Func:
    test byte ptr esi[BREG], 00000001b
    jnz  @BIT0_BBit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT0_BEnd
  @BIT0_BBit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT0_BEnd:
    jmp  @Exit

  @BIT0_C_Func:
    test byte ptr esi[CREG], 00000001b
    jnz  @BIT0_CBit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT0_CEnd
  @BIT0_CBit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT0_CEnd:
    jmp  @Exit

  @BIT0_D_Func:
    test byte ptr esi[DREG], 00000001b
    jnz  @BIT0_DBit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT0_DEnd
  @BIT0_DBit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT0_DEnd:
    jmp  @Exit

  @BIT0_E_Func:
    test byte ptr esi[EREG], 00000001b
    jnz  @BIT0_EBit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT0_EEnd
  @BIT0_EBit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT0_EEnd:
    jmp  @Exit

  @BIT0_H_Func:
    test byte ptr esi[HREG], 00000001b
    jnz  @BIT0_HBit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT0_HEnd
  @BIT0_HBit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT0_HEnd:
    jmp  @Exit

  @BIT0_L_Func:
    test byte ptr esi[LREG], 00000001b
    jnz  @BIT0_LBit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT0_LEnd
  @BIT0_LBit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT0_LEnd:
    jmp  @Exit

  @BIT0_xHL_Func:
    mov  bx, word ptr esi[HLREG]
    call GetByte
    test al, 00000001b
    jnz  @BIT0_xHLBit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT0_xHLEnd
  @BIT0_xHLBit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT0_xHLEnd:
    jmp  @Exit

  @BIT0_A_Func:
    test byte ptr esi[AREG], 00000001b
    jnz  @BIT0_ABit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT0_AEnd
  @BIT0_ABit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT0_AEnd:
    jmp  @Exit

  @BIT1_B_Func:
    test byte ptr esi[BREG], 00000010b
    jnz  @BIT1_BBit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT1_BEnd
  @BIT1_BBit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT1_BEnd:
    jmp  @Exit

  @BIT1_C_Func:
    test byte ptr esi[CREG], 00000010b
    jnz  @BIT1_CBit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT1_CEnd
  @BIT1_CBit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT1_CEnd:
    jmp  @Exit

  @BIT1_D_Func:
    test byte ptr esi[DREG], 00000010b
    jnz  @BIT1_DBit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT1_DEnd
  @BIT1_DBit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT1_DEnd:
    jmp  @Exit

  @BIT1_E_Func:
    test byte ptr esi[EREG], 00000010b
    jnz  @BIT1_EBit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT1_EEnd
  @BIT1_EBit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT1_EEnd:
    jmp  @Exit

  @BIT1_H_Func:
    test byte ptr esi[HREG], 00000010b
    jnz  @BIT1_HBit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT1_HEnd
  @BIT1_HBit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT1_HEnd:
    jmp  @Exit

  @BIT1_L_Func:
    test byte ptr esi[LREG], 00000010b
    jnz  @BIT1_LBit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT1_LEnd
  @BIT1_LBit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT1_LEnd:
    jmp  @Exit

  @BIT1_xHL_Func:
    mov  bx, word ptr esi[HLREG]
    call GetByte
    test al, 00000010b
    jnz  @BIT1_xHLBit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT1_xHLEnd
  @BIT1_xHLBit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT1_xHLEnd:
    jmp  @Exit

  @BIT1_A_Func:
    test byte ptr esi[AREG], 00000010b
    jnz  @BIT1_ABit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT1_AEnd
  @BIT1_ABit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT1_AEnd:
    jmp  @Exit

  @BIT2_B_Func:
    test byte ptr esi[BREG], 00000100b
    jnz  @BIT2_BBit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT2_BEnd
  @BIT2_BBit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT2_BEnd:
    jmp  @Exit

  @BIT2_C_Func:
    test byte ptr esi[CREG], 00000100b
    jnz  @BIT2_CBit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT2_CEnd
  @BIT2_CBit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT2_CEnd:
    jmp  @Exit

  @BIT2_D_Func:
    test byte ptr esi[DREG], 00000100b
    jnz  @BIT2_DBit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT2_DEnd
  @BIT2_DBit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT2_DEnd:
    jmp  @Exit

  @BIT2_E_Func:
    test byte ptr esi[EREG], 00000100b
    jnz  @BIT2_EBit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT2_EEnd
  @BIT2_EBit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT2_EEnd:
    jmp  @Exit

  @BIT2_H_Func:
    test byte ptr esi[HREG], 00000100b
    jnz  @BIT2_HBit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT2_HEnd
  @BIT2_HBit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT2_HEnd:
    jmp  @Exit

  @BIT2_L_Func:
    test byte ptr esi[LREG], 00000100b
    jnz  @BIT2_LBit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT2_LEnd
  @BIT2_LBit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT2_LEnd:
    jmp  @Exit

  @BIT2_xHL_Func:
    mov  bx, word ptr esi[HLREG]
    call GetByte
    test al, 00000100b
    jnz  @BIT2_xHLBit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT2_xHLEnd
  @BIT2_xHLBit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT2_xHLEnd:
    jmp  @Exit

  @BIT2_A_Func:
    test byte ptr esi[AREG], 00000100b
    jnz  @BIT2_ABit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT2_AEnd
  @BIT2_ABit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT2_AEnd:
    jmp  @Exit

  @BIT3_B_Func:
    test byte ptr esi[BREG], 00001000b
    jnz  @BIT3_BBit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT3_BEnd
  @BIT3_BBit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT3_BEnd:
    jmp  @Exit

  @BIT3_C_Func:
    test byte ptr esi[CREG], 00001000b
    jnz  @BIT3_CBit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT3_CEnd
  @BIT3_CBit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT3_CEnd:
    jmp  @Exit

  @BIT3_D_Func:
    test byte ptr esi[DREG], 00001000b
    jnz  @BIT3_DBit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT3_DEnd
  @BIT3_DBit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT3_DEnd:
    jmp  @Exit

  @BIT3_E_Func:
    test byte ptr esi[EREG], 00001000b
    jnz  @BIT3_EBit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT3_EEnd
  @BIT3_EBit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT3_EEnd:
    jmp  @Exit

  @BIT3_H_Func:
    test byte ptr esi[HREG], 00001000b
    jnz  @BIT3_HBit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT3_HEnd
  @BIT3_HBit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT3_HEnd:
    jmp  @Exit

  @BIT3_L_Func:
    test byte ptr esi[LREG], 00001000b
    jnz  @BIT3_LBit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT3_LEnd
  @BIT3_LBit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT3_LEnd:
    jmp  @Exit

  @BIT3_xHL_Func:
    mov  bx, word ptr esi[HLREG]
    call GetByte
    test al, 00001000b
    jnz  @BIT3_xHLBit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT3_xHLEnd
  @BIT3_xHLBit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT3_xHLEnd:
    jmp  @Exit

  @BIT3_A_Func:
    test byte ptr esi[AREG], 00001000b
    jnz  @BIT3_ABit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT3_AEnd
  @BIT3_ABit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT3_AEnd:
    jmp  @Exit

  @BIT4_B_Func:
    test byte ptr esi[BREG], 00010000b
    jnz  @BIT4_BBit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT4_BEnd
  @BIT4_BBit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT4_BEnd:
    jmp  @Exit

  @BIT4_C_Func:
    test byte ptr esi[CREG], 00010000b
    jnz  @BIT4_CBit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT4_CEnd
  @BIT4_CBit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT4_CEnd:
    jmp  @Exit

  @BIT4_D_Func:
    test byte ptr esi[DREG], 00010000b
    jnz  @BIT4_DBit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT4_DEnd
  @BIT4_DBit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT4_DEnd:
    jmp  @Exit

  @BIT4_E_Func:
    test byte ptr esi[EREG], 00010000b
    jnz  @BIT4_EBit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT4_EEnd
  @BIT4_EBit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT4_EEnd:
    jmp  @Exit

  @BIT4_H_Func:
    test byte ptr esi[HREG], 00010000b
    jnz  @BIT4_HBit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT4_HEnd
  @BIT4_HBit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT4_HEnd:
    jmp  @Exit

  @BIT4_L_Func:
    test byte ptr esi[LREG], 00010000b
    jnz  @BIT4_LBit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT4_LEnd
  @BIT4_LBit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT4_LEnd:
    jmp  @Exit

  @BIT4_xHL_Func:
    mov  bx, word ptr esi[HLREG]
    call GetByte
    test al, 00010000b
    jnz  @BIT4_xHLBit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT4_xHLEnd
  @BIT4_xHLBit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT4_xHLEnd:
    jmp  @Exit

  @BIT4_A_Func:
    test byte ptr esi[AREG], 00010000b
    jnz  @BIT4_ABit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT4_AEnd
  @BIT4_ABit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT4_AEnd:
    jmp  @Exit

  @BIT5_B_Func:
    test byte ptr esi[BREG], 00100000b
    jnz  @BIT5_BBit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT5_BEnd
  @BIT5_BBit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT5_BEnd:
    jmp  @Exit

  @BIT5_C_Func:
    test byte ptr esi[CREG], 00100000b
    jnz  @BIT5_CBit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT5_CEnd
  @BIT5_CBit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT5_CEnd:
    jmp  @Exit

  @BIT5_D_Func:
    test byte ptr esi[DREG], 00100000b
    jnz  @BIT5_DBit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT5_DEnd
  @BIT5_DBit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT5_DEnd:
    jmp  @Exit

  @BIT5_E_Func:
    test byte ptr esi[EREG], 00100000b
    jnz  @BIT5_EBit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT5_EEnd
  @BIT5_EBit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT5_EEnd:
    jmp  @Exit

  @BIT5_H_Func:
    test byte ptr esi[HREG], 00100000b
    jnz  @BIT5_HBit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT5_HEnd
  @BIT5_HBit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT5_HEnd:
    jmp  @Exit

  @BIT5_L_Func:
    test byte ptr esi[LREG], 00100000b
    jnz  @BIT5_LBit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT5_LEnd
  @BIT5_LBit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT5_LEnd:
    jmp  @Exit

  @BIT5_xHL_Func:
    mov  bx, word ptr esi[HLREG]
    call GetByte
    test al, 00100000b
    jnz  @BIT5_xHLBit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT5_xHLEnd
  @BIT5_xHLBit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT5_xHLEnd:
    jmp  @Exit

  @BIT5_A_Func:
    test byte ptr esi[AREG], 00100000b
    jnz  @BIT5_ABit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT5_AEnd
  @BIT5_ABit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT5_AEnd:
    jmp  @Exit

  @BIT6_B_Func:
    test byte ptr esi[BREG], 01000000b
    jnz  @BIT6_BBit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT6_BEnd
  @BIT6_BBit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT6_BEnd:
    jmp  @Exit

  @BIT6_C_Func:
    test byte ptr esi[CREG], 01000000b
    jnz  @BIT6_CBit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT6_CEnd
  @BIT6_CBit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT6_CEnd:
    jmp  @Exit

  @BIT6_D_Func:
    test byte ptr esi[DREG], 01000000b
    jnz  @BIT6_DBit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT6_DEnd
  @BIT6_DBit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT6_DEnd:
    jmp  @Exit

  @BIT6_E_Func:
    test byte ptr esi[EREG], 01000000b
    jnz  @BIT6_EBit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT6_EEnd
  @BIT6_EBit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT6_EEnd:
    jmp  @Exit

  @BIT6_H_Func:
    test byte ptr esi[HREG], 01000000b
    jnz  @BIT6_HBit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT6_HEnd
  @BIT6_HBit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT6_HEnd:
    jmp  @Exit

  @BIT6_L_Func:
    test byte ptr esi[LREG], 01000000b
    jnz  @BIT6_LBit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT6_LEnd
  @BIT6_LBit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT6_LEnd:
    jmp  @Exit

  @BIT6_xHL_Func:
    mov  bx, word ptr esi[HLREG]
    call GetByte
    test al, 01000000b
    jnz  @BIT6_xHLBit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT6_xHLEnd
  @BIT6_xHLBit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT6_xHLEnd:
    jmp  @Exit

  @BIT6_A_Func:
    test byte ptr esi[AREG], 01000000b
    jnz  @BIT6_ABit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT6_AEnd
  @BIT6_ABit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT6_AEnd:
    jmp  @Exit

  @BIT7_B_Func:
    test byte ptr esi[BREG], 10000000b
    jnz  @BIT7_BBit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT7_BEnd
  @BIT7_BBit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT7_BEnd:
    jmp  @Exit

  @BIT7_C_Func:
    test byte ptr esi[CREG], 10000000b
    jnz  @BIT7_CBit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT7_CEnd
  @BIT7_CBit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT7_CEnd:
    jmp  @Exit

  @BIT7_D_Func:
    test byte ptr esi[DREG], 10000000b
    jnz  @BIT7_DBit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT7_DEnd
  @BIT7_DBit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT7_DEnd:
    jmp  @Exit

  @BIT7_E_Func:
    test byte ptr esi[EREG], 10000000b
    jnz  @BIT7_EBit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT7_EEnd
  @BIT7_EBit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT7_EEnd:
    jmp  @Exit

  @BIT7_H_Func:
    test byte ptr esi[HREG], 10000000b
    jnz  @BIT7_HBit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT7_HEnd
  @BIT7_HBit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT7_HEnd:
    jmp  @Exit

  @BIT7_L_Func:
    test byte ptr esi[LREG], 10000000b
    jnz  @BIT7_LBit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT7_LEnd
  @BIT7_LBit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT7_LEnd:
    jmp  @Exit

  @BIT7_xHL_Func:
    mov  bx, word ptr esi[HLREG]
    call GetByte
    test al, 10000000b
    jnz  @BIT7_xHLBit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT7_xHLEnd
  @BIT7_xHLBit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT7_xHLEnd:
    jmp  @Exit

  @BIT7_A_Func:
    test byte ptr esi[AREG], 10000000b
    jnz  @BIT7_ABit1
    and  byte ptr esi[FREG], 11111101b
    or   byte ptr esi[FREG], 01010000b
    jmp  @BIT7_AEnd
  @BIT7_ABit1:
    and  byte ptr esi[FREG], 10111101b
    or   byte ptr esi[FREG], 00010000b
  @BIT7_AEnd:
    jmp  @Exit

  @RES0_B_Func:
    and  byte ptr esi[BREG], 11111110b
    jmp  @Exit

  @RES0_C_Func:
    and  byte ptr esi[CREG], 11111110b
    jmp  @Exit

  @RES0_D_Func:
    and  byte ptr esi[DREG], 11111110b
    jmp  @Exit

  @RES0_E_Func:
    and  byte ptr esi[EREG], 11111110b
    jmp  @Exit

  @RES0_H_Func:
    and  byte ptr esi[HREG], 11111110b
    jmp  @Exit

  @RES0_L_Func:
    and  byte ptr esi[LREG], 11111110b
    jmp  @Exit

  @RES0_xHL_Func:
    mov  bx, word ptr esi[HLREG]
    call GetByte
    and  al, 11111110b
    call PutByte
    jmp  @Exit

  @RES0_A_Func:
    and  byte ptr esi[AREG], 11111110b
    jmp  @Exit

  @RES1_B_Func:
    and  byte ptr esi[BREG], 11111101b
    jmp  @Exit

  @RES1_C_Func:
    and  byte ptr esi[CREG], 11111101b
    jmp  @Exit

  @RES1_D_Func:
    and  byte ptr esi[DREG], 11111101b
    jmp  @Exit

  @RES1_E_Func:
    and  byte ptr esi[EREG], 11111101b
    jmp  @Exit

  @RES1_H_Func:
    and  byte ptr esi[HREG], 11111101b
    jmp  @Exit

  @RES1_L_Func:
    and  byte ptr esi[LREG], 11111101b
    jmp  @Exit

  @RES1_xHL_Func:
    mov  bx, word ptr esi[HLREG]
    call GetByte
    and  al, 11111101b
    call PutByte
    jmp  @Exit

  @RES1_A_Func:
    and  byte ptr esi[AREG], 11111101b
    jmp  @Exit

  @RES2_B_Func:
    and  byte ptr esi[BREG], 11111011b
    jmp  @Exit

  @RES2_C_Func:
    and  byte ptr esi[CREG], 11111011b
    jmp  @Exit

  @RES2_D_Func:
    and  byte ptr esi[DREG], 11111011b
    jmp  @Exit

  @RES2_E_Func:
    and  byte ptr esi[EREG], 11111011b
    jmp  @Exit

  @RES2_H_Func:
    and  byte ptr esi[HREG], 11111011b
    jmp  @Exit

  @RES2_L_Func:
    and  byte ptr esi[LREG], 11111011b
    jmp  @Exit

  @RES2_xHL_Func:
    mov  bx, word ptr esi[HLREG]
    call GetByte
    and  al, 11111011b
    call PutByte
    jmp  @Exit

  @RES2_A_Func:
    and  byte ptr esi[AREG], 11111011b
    jmp  @Exit

  @RES3_B_Func:
    and  byte ptr esi[BREG], 11110111b
    jmp  @Exit

  @RES3_C_Func:
    and  byte ptr esi[CREG], 11110111b
    jmp  @Exit

  @RES3_D_Func:
    and  byte ptr esi[DREG], 11110111b
    jmp  @Exit

  @RES3_E_Func:
    and  byte ptr esi[EREG], 11110111b
    jmp  @Exit

  @RES3_H_Func:
    and  byte ptr esi[HREG], 11110111b
    jmp  @Exit

  @RES3_L_Func:
    and  byte ptr esi[LREG], 11110111b
    jmp  @Exit

  @RES3_xHL_Func:
    mov  bx, word ptr esi[HLREG]
    call GetByte
    and  al, 11110111b
    call PutByte
    jmp  @Exit

  @RES3_A_Func:
    and  byte ptr esi[AREG], 11110111b
    jmp  @Exit

  @RES4_B_Func:
    and  byte ptr esi[BREG], 11101111b
    jmp  @Exit

  @RES4_C_Func:
    and  byte ptr esi[CREG], 11101111b
    jmp  @Exit

  @RES4_D_Func:
    and  byte ptr esi[DREG], 11101111b
    jmp  @Exit

  @RES4_E_Func:
    and  byte ptr esi[EREG], 11101111b
    jmp  @Exit

  @RES4_H_Func:
    and  byte ptr esi[HREG], 11101111b
    jmp  @Exit

  @RES4_L_Func:
    and  byte ptr esi[LREG], 11101111b
    jmp  @Exit

  @RES4_xHL_Func:
    mov  bx, word ptr esi[HLREG]
    call GetByte
    and  al, 11101111b
    call PutByte
    jmp  @Exit

  @RES4_A_Func:
    and  byte ptr esi[AREG], 11101111b
    jmp  @Exit

  @RES5_B_Func:
    and  byte ptr esi[BREG], 11011111b
    jmp  @Exit

  @RES5_C_Func:
    and  byte ptr esi[CREG], 11011111b
    jmp  @Exit

  @RES5_D_Func:
    and  byte ptr esi[DREG], 11011111b
    jmp  @Exit

  @RES5_E_Func:
    and  byte ptr esi[EREG], 11011111b
    jmp  @Exit

  @RES5_H_Func:
    and  byte ptr esi[HREG], 11011111b
    jmp  @Exit

  @RES5_L_Func:
    and  byte ptr esi[LREG], 11011111b
    jmp  @Exit

  @RES5_xHL_Func:
    mov  bx, word ptr esi[HLREG]
    call GetByte
    and  al, 11011111b
    call PutByte
    jmp  @Exit

  @RES5_A_Func:
    and  byte ptr esi[AREG], 11011111b
    jmp  @Exit

  @RES6_B_Func:
    and  byte ptr esi[BREG], 10111111b
    jmp  @Exit

  @RES6_C_Func:
    and  byte ptr esi[CREG], 10111111b
    jmp  @Exit

  @RES6_D_Func:
    and  byte ptr esi[DREG], 10111111b
    jmp  @Exit

  @RES6_E_Func:
    and  byte ptr esi[EREG], 10111111b
    jmp  @Exit

  @RES6_H_Func:
    and  byte ptr esi[HREG], 10111111b
    jmp  @Exit

  @RES6_L_Func:
    and  byte ptr esi[LREG], 10111111b
    jmp  @Exit

  @RES6_xHL_Func:
    mov  bx, word ptr esi[HLREG]
    call GetByte
    and  al, 10111111b
    call PutByte
    jmp  @Exit

  @RES6_A_Func:
    and  byte ptr esi[AREG], 10111111b
    jmp  @Exit

  @RES7_B_Func:
    and  byte ptr esi[BREG], 01111111b
    jmp  @Exit

  @RES7_C_Func:
    and  byte ptr esi[CREG], 01111111b
    jmp  @Exit

  @RES7_D_Func:
    and  byte ptr esi[DREG], 01111111b
    jmp  @Exit

  @RES7_E_Func:
    and  byte ptr esi[EREG], 01111111b
    jmp  @Exit

  @RES7_H_Func:
    and  byte ptr esi[HREG], 01111111b
    jmp  @Exit

  @RES7_L_Func:
    and  byte ptr esi[LREG], 01111111b
    jmp  @Exit

  @RES7_xHL_Func:
    mov  bx, word ptr esi[HLREG]
    call GetByte
    and  al, 01111111b
    call PutByte
    jmp  @Exit

  @RES7_A_Func:
    and  byte ptr esi[AREG], 01111111b
    jmp  @Exit

  @SET0_B_Func:
    or   byte ptr esi[BREG], 00000001b
    jmp  @Exit

  @SET0_C_Func:
    or   byte ptr esi[CREG], 00000001b
    jmp  @Exit

  @SET0_D_Func:
    or   byte ptr esi[DREG], 00000001b
    jmp  @Exit

  @SET0_E_Func:
    or   byte ptr esi[EREG], 00000001b
    jmp  @Exit

  @SET0_H_Func:
    or   byte ptr esi[HREG], 00000001b
    jmp  @Exit

  @SET0_L_Func:
    or   byte ptr esi[LREG], 00000001b
    jmp  @Exit

  @SET0_xHL_Func:
    mov  bx, word ptr esi[HLREG]
    call GetByte
    or   al, 00000001b
    call PutByte
    jmp  @Exit

  @SET0_A_Func:
    or   byte ptr esi[AREG], 00000001b
    jmp  @Exit

  @SET1_B_Func:
    or   byte ptr esi[BREG], 00000010b
    jmp  @Exit

  @SET1_C_Func:
    or   byte ptr esi[CREG], 00000010b
    jmp  @Exit

  @SET1_D_Func:
    or   byte ptr esi[DREG], 00000010b
    jmp  @Exit

  @SET1_E_Func:
    or   byte ptr esi[EREG], 00000010b
    jmp  @Exit

  @SET1_H_Func:
    or   byte ptr esi[HREG], 00000010b
    jmp  @Exit

  @SET1_L_Func:
    or   byte ptr esi[LREG], 00000010b
    jmp  @Exit

  @SET1_xHL_Func:
    mov  bx, word ptr esi[HLREG]
    call GetByte
    or   al, 00000010b
    call PutByte
    jmp  @Exit

  @SET1_A_Func:
    or   byte ptr esi[AREG], 00000010b
    jmp  @Exit

  @SET2_B_Func:
    or   byte ptr esi[BREG], 00000100b
    jmp  @Exit

  @SET2_C_Func:
    or   byte ptr esi[CREG], 00000100b
    jmp  @Exit

  @SET2_D_Func:
    or   byte ptr esi[DREG], 00000100b
    jmp  @Exit

  @SET2_E_Func:
    or   byte ptr esi[EREG], 00000100b
    jmp  @Exit

  @SET2_H_Func:
    or   byte ptr esi[HREG], 00000100b
    jmp  @Exit

  @SET2_L_Func:
    or   byte ptr esi[LREG], 00000100b
    jmp  @Exit

  @SET2_xHL_Func:
    mov  bx, word ptr esi[HLREG]
    call GetByte
    or   al, 00000100b
    call PutByte
    jmp  @Exit

  @SET2_A_Func:
    or   byte ptr esi[AREG], 00000100b
    jmp  @Exit

  @SET3_B_Func:
    or   byte ptr esi[BREG], 00001000b
    jmp  @Exit

  @SET3_C_Func:
    or   byte ptr esi[CREG], 00001000b
    jmp  @Exit

  @SET3_D_Func:
    or   byte ptr esi[DREG], 00001000b
    jmp  @Exit

  @SET3_E_Func:
    or   byte ptr esi[EREG], 00001000b
    jmp  @Exit

  @SET3_H_Func:
    or   byte ptr esi[HREG], 00001000b
    jmp  @Exit

  @SET3_L_Func:
    or   byte ptr esi[LREG], 00001000b
    jmp  @Exit

  @SET3_xHL_Func:
    mov  bx, word ptr esi[HLREG]
    call GetByte
    or   al, 00001000b
    call PutByte
    jmp  @Exit

  @SET3_A_Func:
    or   byte ptr esi[AREG], 00001000b
    jmp  @Exit

  @SET4_B_Func:
    or   byte ptr esi[BREG], 00010000b
    jmp  @Exit

  @SET4_C_Func:
    or   byte ptr esi[CREG], 00010000b
    jmp  @Exit

  @SET4_D_Func:
    or   byte ptr esi[DREG], 00010000b
    jmp  @Exit

  @SET4_E_Func:
    or   byte ptr esi[EREG], 00010000b
    jmp  @Exit

  @SET4_H_Func:
    or   byte ptr esi[HREG], 00010000b
    jmp  @Exit

  @SET4_L_Func:
    or   byte ptr esi[LREG], 00010000b
    jmp  @Exit

  @SET4_xHL_Func:
    mov  bx, word ptr esi[HLREG]
    call GetByte
    or   al, 00010000b
    call PutByte
    jmp  @Exit

  @SET4_A_Func:
    or   byte ptr esi[AREG], 00010000b
    jmp  @Exit

  @SET5_B_Func:
    or   byte ptr esi[BREG], 00100000b
    jmp  @Exit

  @SET5_C_Func:
    or   byte ptr esi[CREG], 00100000b
    jmp  @Exit

  @SET5_D_Func:
    or   byte ptr esi[DREG], 00100000b
    jmp  @Exit

  @SET5_E_Func:
    or   byte ptr esi[EREG], 00100000b
    jmp  @Exit

  @SET5_H_Func:
    or   byte ptr esi[HREG], 00100000b
    jmp  @Exit

  @SET5_L_Func:
    or   byte ptr esi[LREG], 00100000b
    jmp  @Exit

  @SET5_xHL_Func:
    mov  bx, word ptr esi[HLREG]
    call GetByte
    or   al, 00100000b
    call PutByte
    jmp  @Exit

  @SET5_A_Func:
    or   byte ptr esi[AREG], 00100000b
    jmp  @Exit

  @SET6_B_Func:
    or   byte ptr esi[BREG], 01000000b
    jmp  @Exit

  @SET6_C_Func:
    or   byte ptr esi[CREG], 01000000b
    jmp  @Exit

  @SET6_D_Func:
    or   byte ptr esi[DREG], 01000000b
    jmp  @Exit

  @SET6_E_Func:
    or   byte ptr esi[EREG], 01000000b
    jmp  @Exit

  @SET6_H_Func:
    or   byte ptr esi[HREG], 01000000b
    jmp  @Exit

  @SET6_L_Func:
    or   byte ptr esi[LREG], 01000000b
    jmp  @Exit

  @SET6_xHL_Func:
    mov  bx, word ptr esi[HLREG]
    call GetByte
    or   al, 01000000b
    call PutByte
    jmp  @Exit

  @SET6_A_Func:
    or   byte ptr esi[AREG], 01000000b
    jmp  @Exit

  @SET7_B_Func:
    or   byte ptr esi[BREG], 10000000b
    jmp  @Exit

  @SET7_C_Func:
    or   byte ptr esi[CREG], 10000000b
    jmp  @Exit

  @SET7_D_Func:
    or   byte ptr esi[DREG], 10000000b
    jmp  @Exit

  @SET7_E_Func:
    or   byte ptr esi[EREG], 10000000b
    jmp  @Exit

  @SET7_H_Func:
    or   byte ptr esi[HREG], 10000000b
    jmp  @Exit

  @SET7_L_Func:
    or   byte ptr esi[LREG], 10000000b
    jmp  @Exit

  @SET7_xHL_Func:
    mov  bx, word ptr esi[HLREG]
    call GetByte
    or   al, 10000000b
    call PutByte
    jmp  @Exit

  @SET7_A_Func:
    or   byte ptr esi[AREG], 10000000b
    jmp  @Exit

  @Exit:
end;
