procedure OpCodeFD; assembler;
asm
    xor  eax, eax
    mov  bx, word ptr esi[PCREG]
    call GetByte
    inc  word ptr esi[PCREG]
    and  eax, $FFFF

    { Update tick counter }
    mov  ebx, eax
    xor  cx, cx
    mov  cl, byte ptr oCyclesXX[ebx]
    add  word ptr esi[TICKCOUNT], cx

    shl  eax, 3
    mov  ebx, offset @IY_NOP
    add  eax, ebx
    jmp  eax
  @IY_NOP:
    nop
    nop
    jmp  @IY_NOP_Func
    nop

  @IY_LD_BC_WORD:
    nop
    nop
    jmp  @IY_LD_BC_WORD_Func
    nop

  @IY_LD_xBC_A:
    nop
    nop
    jmp  @IY_LD_xBC_A_Func
    nop

  @IY_INC_BC:
    nop
    nop
    jmp  @IY_INC_BC_Func
    nop

  @IY_INC_B:
    nop
    nop
    jmp  @IY_INC_B_Func
    nop

  @IY_DEC_B:
    nop
    nop
    jmp  @IY_DEC_B_Func
    nop

  @IY_LD_B_BYTE:
    nop
    nop
    jmp  @IY_LD_B_BYTE_Func
    nop

  @IY_RLCA:
    nop
    nop
    jmp  @IY_RLCA_Func
    nop

  @IY_EX_AF_AF:
    nop
    nop
    jmp  @IY_EX_AF_AF_Func
    nop

  @IY_ADD_HL_BC:
    nop
    nop
    jmp  @IY_ADD_HL_BC_Func
    nop

  @IY_LD_A_xBC:
    nop
    nop
    jmp  @IY_LD_A_xBC_Func
    nop

  @IY_DEC_BC:
    nop
    nop
    jmp  @IY_DEC_BC_Func
    nop

  @IY_INC_C:
    nop
    nop
    jmp  @IY_INC_C_Func
    nop

  @IY_DEC_C:
    nop
    nop
    jmp  @IY_DEC_C_Func
    nop

  @IY_LD_C_BYTE:
    nop
    nop
    jmp  @IY_LD_C_BYTE_Func
    nop

  @IY_RRCA:
    nop
    nop
    jmp  @IY_RRCA_Func
    nop

  @IY_DJNZ:
    nop
    nop
    jmp  @IY_DJNZ_Func
    nop

  @IY_LD_DE_WORD:
    nop
    nop
    jmp  @IY_LD_DE_WORD_Func
    nop

  @IY_LD_xDE_A:
    nop
    nop
    jmp  @IY_LD_xDE_A_Func
    nop

  @IY_INC_DE:
    nop
    nop
    jmp  @IY_INC_DE_Func
    nop

  @IY_INC_D:
    nop
    nop
    jmp  @IY_INC_D_Func
    nop

  @IY_DEC_D:
    nop
    nop
    jmp  @IY_DEC_D_Func
    nop

  @IY_LD_D_BYTE:
    nop
    nop
    jmp  @IY_LD_D_BYTE_Func
    nop

  @IY_RLA:
    nop
    nop
    jmp  @IY_RLA_Func
    nop

  @IY_JR:
    nop
    nop
    jmp  @IY_JR_Func
    nop

  @IY_ADD_HL_DE:
    nop
    nop
    jmp  @IY_ADD_HL_DE_Func
    nop

  @IY_LD_A_xDE:
    nop
    nop
    jmp  @IY_LD_A_xDE_Func
    nop

  @IY_DEC_DE:
    nop
    nop
    jmp  @IY_DEC_DE_Func
    nop

  @IY_INC_E:
    nop
    nop
    jmp  @IY_INC_E_Func
    nop

  @IY_DEC_E:
    nop
    nop
    jmp  @IY_DEC_E_Func
    nop

  @IY_LD_E_BYTE:
    nop
    nop
    jmp  @IY_LD_E_BYTE_Func
    nop

  @IY_RRA:
    nop
    nop
    jmp  @IY_RRA_Func
    nop

  @IY_JR_NZ:
    nop
    nop
    jmp  @IY_JR_NZ_Func
    nop

  @IY_LD_HL_WORD:
    nop
    nop
    jmp  @IY_LD_HL_WORD_Func
    nop

  @IY_LD_xWORD_HL:
    nop
    nop
    jmp  @IY_LD_xWORD_HL_Func
    nop

  @IY_INC_HL:
    nop
    nop
    jmp  @IY_INC_HL_Func
    nop

  @IY_INC_H:
    nop
    nop
    jmp  @IY_INC_H_Func
    nop

  @IY_DEC_H:
    nop
    nop
    jmp  @IY_DEC_H_Func
    nop

  @IY_LD_H_BYTE:
    nop
    nop
    jmp  @IY_LD_H_BYTE_Func
    nop

  @IY_DAA:
    nop
    nop
    jmp  @IY_DAA_Func
    nop

  @IY_JR_Z:
    nop
    nop
    jmp  @IY_JR_Z_Func
    nop

  @IY_ADD_HL_HL:
    nop
    nop
    jmp  @IY_ADD_HL_HL_Func
    nop

  @IY_LD_HL_xWORD:
    nop
    nop
    jmp  @IY_LD_HL_xWORD_Func
    nop

  @IY_DEC_HL:
    nop
    nop
    jmp  @IY_DEC_HL_Func
    nop

  @IY_INC_L:
    nop
    nop
    jmp  @IY_INC_L_Func
    nop

  @IY_DEC_L:
    nop
    nop
    jmp  @IY_DEC_L_Func
    nop

  @IY_LD_L_BYTE:
    nop
    nop
    jmp  @IY_LD_L_BYTE_Func
    nop

  @IY_CPL:
    nop
    nop
    jmp  @IY_CPL_Func
    nop

  @IY_JR_NC:
    nop
    nop
    jmp  @IY_JR_NC_Func
    nop

  @IY_LD_SP_WORD:
    nop
    nop
    jmp  @IY_LD_SP_WORD_Func
    nop

  @IY_LD_xWORD_A:
    nop
    nop
    jmp  @IY_LD_xWORD_A_Func
    nop

  @IY_INC_SP:
    nop
    nop
    jmp  @IY_INC_SP_Func
    nop

  @IY_INC_xHL:
    nop
    nop
    jmp  @IY_INC_xHL_Func
    nop

  @IY_DEC_xHL:
    nop
    nop
    jmp  @IY_DEC_xHL_Func
    nop

  @IY_LD_xHL_BYTE:
    nop
    nop
    jmp  @IY_LD_xHL_BYTE_Func
    nop

  @IY_SCF:
    nop
    nop
    jmp  @IY_SCF_Func
    nop

  @IY_JR_C:
    nop
    nop
    jmp  @IY_JR_C_Func
    nop

  @IY_ADD_HL_SP:
    nop
    nop
    jmp  @IY_ADD_HL_SP_Func
    nop

  @IY_LD_A_xWORD:
    nop
    nop
    jmp  @IY_LD_A_xWORD_Func
    nop

  @IY_DEC_SP:
    nop
    nop
    jmp  @IY_DEC_SP_Func
    nop

  @IY_INC_A:
    nop
    nop
    jmp  @IY_INC_A_Func
    nop

  @IY_DEC_A:
    nop
    nop
    jmp  @IY_DEC_A_Func
    nop

  @IY_LD_A_BYTE:
    nop
    nop
    jmp  @IY_LD_A_BYTE_Func
    nop

  @IY_CCF:
    nop
    nop
    jmp  @IY_CCF_Func
    nop

  @IY_LD_B_B:
    nop
    nop
    jmp  @IY_LD_B_B_Func
    nop

  @IY_LD_B_C:
    nop
    nop
    jmp  @IY_LD_B_C_Func
    nop

  @IY_LD_B_D:
    nop
    nop
    jmp  @IY_LD_B_D_Func
    nop

  @IY_LD_B_E:
    nop
    nop
    jmp  @IY_LD_B_E_Func
    nop

  @IY_LD_B_H:
    nop
    nop
    jmp  @IY_LD_B_H_Func
    nop

  @IY_LD_B_L:
    nop
    nop
    jmp  @IY_LD_B_L_Func
    nop

  @IY_LD_B_xHL:
    nop
    nop
    jmp  @IY_LD_B_xHL_Func
    nop

  @IY_LD_B_A:
    nop
    nop
    jmp  @IY_LD_B_A_Func
    nop

  @IY_LD_C_B:
    nop
    nop
    jmp  @IY_LD_C_B_Func
    nop

  @IY_LD_C_C:
    nop
    nop
    jmp  @IY_LD_C_C_Func
    nop

  @IY_LD_C_D:
    nop
    nop
    jmp  @IY_LD_C_D_Func
    nop

  @IY_LD_C_E:
    nop
    nop
    jmp  @IY_LD_C_E_Func
    nop

  @IY_LD_C_H:
    nop
    nop
    jmp  @IY_LD_C_H_Func
    nop

  @IY_LD_C_L:
    nop
    nop
    jmp  @IY_LD_C_L_Func
    nop

  @IY_LD_C_xHL:
    nop
    nop
    jmp  @IY_LD_C_xHL_Func
    nop

  @IY_LD_C_A:
    nop
    nop
    jmp  @IY_LD_C_A_Func
    nop

  @IY_LD_D_B:
    nop
    nop
    jmp  @IY_LD_D_B_Func
    nop

  @IY_LD_D_C:
    nop
    nop
    jmp  @IY_LD_D_C_Func
    nop

  @IY_LD_D_D:
    nop
    nop
    jmp  @IY_LD_D_D_Func
    nop

  @IY_LD_D_E:
    nop
    nop
    jmp  @IY_LD_D_E_Func
    nop

  @IY_LD_D_H:
    nop
    nop
    jmp  @IY_LD_D_H_Func
    nop

  @IY_LD_D_L:
    nop
    nop
    jmp  @IY_LD_D_L_Func
    nop

  @IY_LD_D_xHL:
    nop
    nop
    jmp  @IY_LD_D_xHL_Func
    nop

  @IY_LD_D_A:
    nop
    nop
    jmp  @IY_LD_D_A_Func
    nop

  @IY_LD_E_B:
    nop
    nop
    jmp  @IY_LD_E_B_Func
    nop

  @IY_LD_E_C:
    nop
    nop
    jmp  @IY_LD_E_C_Func
    nop

  @IY_LD_E_D:
    nop
    nop
    jmp  @IY_LD_E_D_Func
    nop

  @IY_LD_E_E:
    nop
    nop
    jmp  @IY_LD_E_E_Func
    nop

  @IY_LD_E_H:
    nop
    nop
    jmp  @IY_LD_E_H_Func
    nop

  @IY_LD_E_L:
    nop
    nop
    jmp  @IY_LD_E_L_Func
    nop

  @IY_LD_E_xHL:
    nop
    nop
    jmp  @IY_LD_E_xHL_Func
    nop

  @IY_LD_E_A:
    nop
    nop
    jmp  @IY_LD_E_A_Func
    nop

  @IY_LD_H_B:
    nop
    nop
    jmp  @IY_LD_H_B_Func
    nop

  @IY_LD_H_C:
    nop
    nop
    jmp  @IY_LD_H_C_Func
    nop

  @IY_LD_H_D:
    nop
    nop
    jmp  @IY_LD_H_D_Func
    nop

  @IY_LD_H_E:
    nop
    nop
    jmp  @IY_LD_H_E_Func
    nop

  @IY_LD_H_H:
    nop
    nop
    jmp  @IY_LD_H_H_Func
    nop

  @IY_LD_H_L:
    nop
    nop
    jmp  @IY_LD_H_L_Func
    nop

  @IY_LD_H_xHL:
    nop
    nop
    jmp  @IY_LD_H_xHL_Func
    nop

  @IY_LD_H_A:
    nop
    nop
    jmp  @IY_LD_H_A_Func
    nop

  @IY_LD_L_B:
    nop
    nop
    jmp  @IY_LD_L_B_Func
    nop

  @IY_LD_L_C:
    nop
    nop
    jmp  @IY_LD_L_C_Func
    nop

  @IY_LD_L_D:
    nop
    nop
    jmp  @IY_LD_L_D_Func
    nop

  @IY_LD_L_E:
    nop
    nop
    jmp  @IY_LD_L_E_Func
    nop

  @IY_LD_L_H:
    nop
    nop
    jmp  @IY_LD_L_H_Func
    nop

  @IY_LD_L_L:
    nop
    nop
    jmp  @IY_LD_L_L_Func
    nop

  @IY_LD_L_xHL:
    nop
    nop
    jmp  @IY_LD_L_xHL_Func
    nop

  @IY_LD_L_A:
    nop
    nop
    jmp  @IY_LD_L_A_Func
    nop

  @IY_LD_xHL_B:
    nop
    nop
    jmp  @IY_LD_xHL_B_Func
    nop

  @IY_LD_xHL_C:
    nop
    nop
    jmp  @IY_LD_xHL_C_Func
    nop

  @IY_LD_xHL_D:
    nop
    nop
    jmp  @IY_LD_xHL_D_Func
    nop

  @IY_LD_xHL_E:
    nop
    nop
    jmp  @IY_LD_xHL_E_Func
    nop

  @IY_LD_xHL_H:
    nop
    nop
    jmp  @IY_LD_xHL_H_Func
    nop

  @IY_LD_xHL_L:
    nop
    nop
    jmp  @IY_LD_xHL_L_Func
    nop

  @IY_HALT:
    nop
    nop
    jmp  @IY_HALT_Func
    nop

  @IY_LD_xHL_A:
    nop
    nop
    jmp  @IY_LD_xHL_A_Func
    nop

  @IY_LD_A_B:
    nop
    nop
    jmp  @IY_LD_A_B_Func
    nop

  @IY_LD_A_C:
    nop
    nop
    jmp  @IY_LD_A_C_Func
    nop

  @IY_LD_A_D:
    nop
    nop
    jmp  @IY_LD_A_D_Func
    nop

  @IY_LD_A_E:
    nop
    nop
    jmp  @IY_LD_A_E_Func
    nop

  @IY_LD_A_H:
    nop
    nop
    jmp  @IY_LD_A_H_Func
    nop

  @IY_LD_A_L:
    nop
    nop
    jmp  @IY_LD_A_L_Func
    nop

  @IY_LD_A_xHL:
    nop
    nop
    jmp  @IY_LD_A_xHL_Func
    nop

  @IY_LD_A_A:
    nop
    nop
    jmp  @IY_LD_A_A_Func
    nop

  @IY_ADD_B:
    nop
    nop
    jmp  @IY_ADD_B_Func
    nop

  @IY_ADD_C:
    nop
    nop
    jmp  @IY_ADD_C_Func
    nop

  @IY_ADD_D:
    nop
    nop
    jmp  @IY_ADD_D_Func
    nop

  @IY_ADD_E:
    nop
    nop
    jmp  @IY_ADD_E_Func
    nop

  @IY_ADD_H:
    nop
    nop
    jmp  @IY_ADD_H_Func
    nop

  @IY_ADD_L:
    nop
    nop
    jmp  @IY_ADD_L_Func
    nop

  @IY_ADD_xHL:
    nop
    nop
    jmp  @IY_ADD_xHL_Func
    nop

  @IY_ADD_A:
    nop
    nop
    jmp  @IY_ADD_A_Func
    nop

  @IY_ADC_B:
    nop
    nop
    jmp  @IY_ADC_B_Func
    nop

  @IY_ADC_C:
    nop
    nop
    jmp  @IY_ADC_C_Func
    nop

  @IY_ADC_D:
    nop
    nop
    jmp  @IY_ADC_D_Func
    nop

  @IY_ADC_E:
    nop
    nop
    jmp  @IY_ADC_E_Func
    nop

  @IY_ADC_H:
    nop
    nop
    jmp  @IY_ADC_H_Func
    nop

  @IY_ADC_L:
    nop
    nop
    jmp  @IY_ADC_L_Func
    nop

  @IY_ADC_xHL:
    nop
    nop
    jmp  @IY_ADC_xHL_Func
    nop

  @IY_ADC_A:
    nop
    nop
    jmp  @IY_ADC_A_Func
    nop

  @IY_SUB_B:
    nop
    nop
    jmp  @IY_SUB_B_Func
    nop

  @IY_SUB_C:
    nop
    nop
    jmp  @IY_SUB_C_Func
    nop

  @IY_SUB_D:
    nop
    nop
    jmp  @IY_SUB_D_Func
    nop

  @IY_SUB_E:
    nop
    nop
    jmp  @IY_SUB_E_Func
    nop

  @IY_SUB_H:
    nop
    nop
    jmp  @IY_SUB_H_Func
    nop

  @IY_SUB_L:
    nop
    nop
    jmp  @IY_SUB_L_Func
    nop

  @IY_SUB_xHL:
    nop
    nop
    jmp  @IY_SUB_xHL_Func
    nop

  @IY_SUB_A:
    nop
    nop
    jmp  @IY_SUB_A_Func
    nop

  @IY_SBC_B:
    nop
    nop
    jmp  @IY_SBC_B_Func
    nop

  @IY_SBC_C:
    nop
    nop
    jmp  @IY_SBC_C_Func
    nop

  @IY_SBC_D:
    nop
    nop
    jmp  @IY_SBC_D_Func
    nop

  @IY_SBC_E:
    nop
    nop
    jmp  @IY_SBC_E_Func
    nop

  @IY_SBC_H:
    nop
    nop
    jmp  @IY_SBC_H_Func
    nop

  @IY_SBC_L:
    nop
    nop
    jmp  @IY_SBC_L_Func
    nop

  @IY_SBC_xHL:
    nop
    nop
    jmp  @IY_SBC_xHL_Func
    nop

  @IY_SBC_A:
    nop
    nop
    jmp  @IY_SBC_A_Func
    nop

  @IY_AND_B:
    nop
    nop
    jmp  @IY_AND_B_Func
    nop

  @IY_AND_C:
    nop
    nop
    jmp  @IY_AND_C_Func
    nop

  @IY_AND_D:
    nop
    nop
    jmp  @IY_AND_D_Func
    nop

  @IY_AND_E:
    nop
    nop
    jmp  @IY_AND_E_Func
    nop

  @IY_AND_H:
    nop
    nop
    jmp  @IY_AND_H_Func
    nop

  @IY_AND_L:
    nop
    nop
    jmp  @IY_AND_L_Func
    nop

  @IY_AND_xHL:
    nop
    nop
    jmp  @IY_AND_xHL_Func
    nop

  @IY_AND_A:
    nop
    nop
    jmp  @IY_AND_A_Func
    nop

  @IY_XOR_B:
    nop
    nop
    jmp  @IY_XOR_B_Func
    nop

  @IY_XOR_C:
    nop
    nop
    jmp  @IY_XOR_C_Func
    nop

  @IY_XOR_D:
    nop
    nop
    jmp  @IY_XOR_D_Func
    nop

  @IY_XOR_E:
    nop
    nop
    jmp  @IY_XOR_E_Func
    nop

  @IY_XOR_H:
    nop
    nop
    jmp  @IY_XOR_H_Func
    nop

  @IY_XOR_L:
    nop
    nop
    jmp  @IY_XOR_L_Func
    nop

  @IY_XOR_xHL:
    nop
    nop
    jmp  @IY_XOR_xHL_Func
    nop

  @IY_XOR_A:
    nop
    nop
    jmp  @IY_XOR_A_Func
    nop

  @IY_OR_B:
    nop
    nop
    jmp  @IY_OR_B_Func
    nop

  @IY_OR_C:
    nop
    nop
    jmp  @IY_OR_C_Func
    nop

  @IY_OR_D:
    nop
    nop
    jmp  @IY_OR_D_Func
    nop

  @IY_OR_E:
    nop
    nop
    jmp  @IY_OR_E_Func
    nop

  @IY_OR_H:
    nop
    nop
    jmp  @IY_OR_H_Func
    nop

  @IY_OR_L:
    nop
    nop
    jmp  @IY_OR_L_Func
    nop

  @IY_OR_xHL:
    nop
    nop
    jmp  @IY_OR_xHL_Func
    nop

  @IY_OR_A:
    nop
    nop
    jmp  @IY_OR_A_Func
    nop

  @IY_CP_B:
    nop
    nop
    jmp  @IY_CP_B_Func
    nop

  @IY_CP_C:
    nop
    nop
    jmp  @IY_CP_C_Func
    nop

  @IY_CP_D:
    nop
    nop
    jmp  @IY_CP_D_Func
    nop

  @IY_CP_E:
    nop
    nop
    jmp  @IY_CP_E_Func
    nop

  @IY_CP_H:
    nop
    nop
    jmp  @IY_CP_H_Func
    nop

  @IY_CP_L:
    nop
    nop
    jmp  @IY_CP_L_Func
    nop

  @IY_CP_xHL:
    nop
    nop
    jmp  @IY_CP_xHL_Func
    nop

  @IY_CP_A:
    nop
    nop
    jmp  @IY_CP_A_Func
    nop

  @IY_RET_NZ:
    nop
    nop
    jmp  @IY_RET_NZ_Func
    nop

  @IY_POP_BC:
    nop
    nop
    jmp  @IY_POP_BC_Func
    nop

  @IY_JP_NZ:
    nop
    nop
    jmp  @IY_JP_NZ_Func
    nop

  @IY_JP:
    nop
    nop
    jmp  @IY_JP_Func
    nop

  @IY_CALL_NZ:
    nop
    nop
    jmp  @IY_CALL_NZ_Func
    nop

  @IY_PUSH_BC:
    nop
    nop
    jmp  @IY_PUSH_BC_Func
    nop

  @IY_ADD_BYTE:
    nop
    nop
    jmp  @IY_ADD_BYTE_Func
    nop

  @IY_RST00:
    nop
    nop
    jmp  @IY_RST00_Func
    nop

  @IY_RET_Z:
    nop
    nop
    jmp  @IY_RET_Z_Func
    nop

  @IY_RET:
    nop
    nop
    jmp  @IY_RET_Func
    nop

  @IY_JP_Z:
    nop
    nop
    jmp  @IY_JP_Z_Func
    nop

  @IY_PFX_CB:
    nop
    nop
    jmp  @IY_PFX_CB_Func
    nop

  @IY_CALL_Z:
    nop
    nop
    jmp  @IY_CALL_Z_Func
    nop

  @IY_CALL:
    nop
    nop
    jmp  @IY_CALL_Func
    nop

  @IY_ADC_BYTE:
    nop
    nop
    jmp  @IY_ADC_BYTE_Func
    nop

  @IY_RST08:
    nop
    nop
    jmp  @IY_RST08_Func
    nop

  @IY_RET_NC:
    nop
    nop
    jmp  @IY_RET_NC_Func
    nop

  @IY_POP_DE:
    nop
    nop
    jmp  @IY_POP_DE_Func
    nop

  @IY_JP_NC:
    nop
    nop
    jmp  @IY_JP_NC_Func
    nop

  @IY_OUTA:
    nop
    nop
    jmp  @IY_OUTA_Func
    nop

  @IY_CALL_NC:
    nop
    nop
    jmp  @IY_CALL_NC_Func
    nop

  @IY_PUSH_DE:
    nop
    nop
    jmp  @IY_PUSH_DE_Func
    nop

  @IY_SUB_BYTE:
    nop
    nop
    jmp  @IY_SUB_BYTE_Func
    nop

  @IY_RST10:
    nop
    nop
    jmp  @IY_RST10_Func
    nop

  @IY_RET_C:
    nop
    nop
    jmp  @IY_RET_C_Func
    nop

  @IY_EXX:
    nop
    nop
    jmp  @IY_EXX_Func
    nop

  @IY_JP_C:
    nop
    nop
    jmp  @IY_JP_C_Func
    nop

  @IY_INA:
    nop
    nop
    jmp  @IY_INA_Func
    nop

  @IY_CALL_C:
    nop
    nop
    jmp  @IY_CALL_C_Func
    nop

  @IY_PFX_DD:
    nop
    nop
    jmp  @IY_PFX_DD_Func
    nop

  @IY_SBC_BYTE:
    nop
    nop
    jmp  @IY_SBC_BYTE_Func
    nop

  @IY_RST18:
    nop
    nop
    jmp  @IY_RST18_Func
    nop

  @IY_RET_PO:
    nop
    nop
    jmp  @IY_RET_PO_Func
    nop

  @IY_POP_HL:
    nop
    nop
    jmp  @IY_POP_HL_Func
    nop

  @IY_JP_PO:
    nop
    nop
    jmp  @IY_JP_PO_Func
    nop

  @IY_EX_HL_xSP:
    nop
    nop
    jmp  @IY_EX_HL_xSP_Func
    nop

  @IY_CALL_PO:
    nop
    nop
    jmp  @IY_CALL_PO_Func
    nop

  @IY_PUSH_HL:
    nop
    nop
    jmp  @IY_PUSH_HL_Func
    nop

  @IY_AND_BYTE:
    nop
    nop
    jmp  @IY_AND_BYTE_Func
    nop

  @IY_RST20:
    nop
    nop
    jmp  @IY_RST20_Func
    nop

  @IY_RET_PE:
    nop
    nop
    jmp  @IY_RET_PE_Func
    nop

  @IY_LD_PC_HL:
    nop
    nop
    jmp  @IY_LD_PC_HL_Func
    nop

  @IY_JP_PE:
    nop
    nop
    jmp  @IY_JP_PE_Func
    nop

  @IY_EX_DE_HL:
    nop
    nop
    jmp  @IY_EX_DE_HL_Func
    nop

  @IY_CALL_PE:
    nop
    nop
    jmp  @IY_CALL_PE_Func
    nop

  @IY_PFX_ED:
    nop
    nop
    jmp  @IY_PFX_ED_Func
    nop

  @IY_XOR_BYTE:
    nop
    nop
    jmp  @IY_XOR_BYTE_Func
    nop

  @IY_RST28:
    nop
    nop
    jmp  @IY_RST28_Func
    nop

  @IY_RET_P:
    nop
    nop
    jmp  @IY_RET_P_Func
    nop

  @IY_POP_AF:
    nop
    nop
    jmp  @IY_POP_AF_Func
    nop

  @IY_JP_P:
    nop
    nop
    jmp  @IY_JP_P_Func
    nop

  @IY_DI:
    nop
    nop
    jmp  @IY_DI_Func
    nop

  @IY_CALL_P:
    nop
    nop
    jmp  @IY_CALL_P_Func
    nop

  @IY_PUSH_AF:
    nop
    nop
    jmp  @IY_PUSH_AF_Func
    nop

  @IY_OR_BYTE:
    nop
    nop
    jmp  @IY_OR_BYTE_Func
    nop

  @IY_RST30:
    nop
    nop
    jmp  @IY_RST30_Func
    nop

  @IY_RET_M:
    nop
    nop
    jmp  @IY_RET_M_Func
    nop

  @IY_LD_SP_HL:
    nop
    nop
    jmp  @IY_LD_SP_HL_Func
    nop

  @IY_JP_M:
    nop
    nop
    jmp  @IY_JP_M_Func
    nop

  @IY_EI:
    nop
    nop
    jmp  @IY_EI_Func
    nop

  @IY_CALL_M:
    nop
    nop
    jmp  @IY_CALL_M_Func
    nop

  @IY_PFX_FD:
    nop
    nop
    jmp  @IY_PFX_FD_Func
    nop

  @IY_CP_BYTE:
    nop
    nop
    jmp  @IY_CP_BYTE_Func
    nop

  @IY_RST38:
    nop
    nop
    jmp  @IY_RST38_Func
    nop

  @IY_NOP_Func:
  { nop }
    jmp  @Exit

  @IY_LD_BC_WORD_Func:
    mov  bx, word ptr esi[PCREG]  { bx <- PC      }
    call GetByte                 { al <- MEM[PC] }
    xchg ah, al                  { change ah with al }
    inc  bx
    call GetByte                 { al <- MEM[PC+1] }
    xchg ah, al                  { change ah with al, ax <- MEMW[PC] }
    inc  word ptr esi[PCREG]
    inc  word ptr esi[PCREG]      { PC = PC+2: skip word value }
    mov  word ptr esi[BCREG], ax  { BC <- ax }
    jmp  @Exit

  @IY_LD_xBC_A_Func:
    mov  bx, word ptr esi[BCREG]  { bx <- BC}
    mov  al, byte ptr esi[AREG]   { al <- A}
    call PutByte                 { MEM[bx] <- al }
    jmp  @Exit

  @IY_INC_BC_Func:
    inc  word ptr esi[BCREG]
    jmp  @Exit

  @IY_INC_B_Func:
    xor  ebx, ebx
    mov  bl, byte ptr esi[BREG]
    mov  al, byte ptr aIncTable[ebx]
    and  byte ptr esi[FREG], U1FLAG or U2FLAG or C_FLAG   { dont change carry flag } 
    or   byte ptr esi[FREG],al
    inc  byte ptr esi[BREG]
    jmp  @Exit

  @IY_DEC_B_Func:
    xor  ebx, ebx
    mov  bl, byte ptr esi[BREG]
    mov  al, byte ptr aDecTable[ebx]
    and  byte ptr esi[FREG], U1FLAG or U2FLAG or C_FLAG   { dont change carry flag } 
    or   byte ptr esi[FREG],al
    dec  byte ptr esi[BREG]
    jmp  @Exit

  @IY_LD_B_BYTE_Func:
    mov  bx, word ptr esi[PCREG]      { bx <- PC }
    inc  word ptr esi[PCREG]          { skip one byte }
    call GetByte                     { al <- MEM[PC] }
    mov  byte ptr esi[BREG], al       { B <- al }
    jmp  @Exit

  @IY_RLCA_Func:
    rol  byte ptr esi[AREG], 1
    jc   @Set_Carry_RLCA
    { Clear half carry, n flag and carry flag }
    and  byte ptr esi[FREG], ($FF xor (H_FLAG or N_FLAG or C_FLAG))
    jmp  @RLCAExit
  @Set_Carry_RLCA:
    { Clear half carry and n flag }
    and  byte ptr esi[FREG], ($FF xor (H_FLAG or N_FLAG))
    or   byte ptr esi[FREG], C_FLAG      { Set Carry flag }
  @RLCAExit:
    jmp  @Exit

  @IY_EX_AF_AF_Func:
    mov ax, word ptr esi[AF1REG]       { ax <- AF1}
    mov bx, word ptr esi[AFREG]       { bx <- AF}
    mov word ptr esi[AFREG], ax       { AF <- ax }
    mov word ptr esi[AF1REG], bx       { AF1 <- bx }
    jmp  @Exit

  @IY_ADD_HL_BC_Func:
    { clear half, n and carry flags }
    and  byte ptr esi[FREG], ($FF xor (H_FLAG or N_FLAG or C_FLAG))
    mov  ax, word ptr esi[BCREG]
    add  word ptr esi[IYREG] , ax
    jnc  @CarryNotRaised_ADD_IY_BC
    or   byte ptr esi[FREG], C_FLAG      { set C flag }
  @CarryNotRaised_ADD_IY_BC:
    mov  ax, word ptr esi[BCREG]
    xor  ax, word ptr esi[IYREG]
    and  ax, $1000
    jz   @Exit
    or   byte ptr esi[FREG], H_FLAG      { set H Flag }
    jmp  @Exit

  @IY_LD_A_xBC_Func:
    mov  bx, word ptr esi[BCREG]  { bx <- BC}
    call GetByte
    mov  byte ptr esi[AREG], al
    jmp  @Exit

  @IY_DEC_BC_Func:
    dec  word ptr esi[BCREG]
    jmp  @Exit

  @IY_INC_C_Func:
    xor  ebx, ebx
    mov  bl, byte ptr esi[CREG]
    mov  al, byte ptr aIncTable[ebx]
    and  byte ptr esi[FREG], U1FLAG or U2FLAG or C_FLAG   { dont change carry flag } 
    or   byte ptr esi[FREG],al
    inc  byte ptr esi[CREG]
    jmp  @Exit

  @IY_DEC_C_Func:
    xor  ebx, ebx
    mov  bl, byte ptr esi[CREG]
    mov  al, byte ptr aDecTable[ebx]
    and  byte ptr esi[FREG], U1FLAG or U2FLAG or C_FLAG   { dont change carry flag } 
    or   byte ptr esi[FREG],al
    dec  byte ptr esi[CREG]
    jmp  @Exit

  @IY_LD_C_BYTE_Func:
    mov  bx, word ptr esi[PCREG]      { bx <- PC }
    inc  word ptr esi[PCREG]          { skip one byte }
    call GetByte                     { al <- MEM[PC] }
    mov  byte ptr esi[CREG], al       { C <- al }
    jmp  @Exit

  @IY_RRCA_Func:
    ror  byte ptr esi[AREG], 1
    jc   @Set_Carry_RRCA
    { Clear half carry, n flag and carry flag }
    and  byte ptr esi[FREG], ($FF xor (H_FLAG or N_FLAG or C_FLAG))
    jmp  @RRCAExit
  @Set_Carry_RRCA:
    { Clear half carry and n flag }
    and  byte ptr esi[FREG], ($FF xor (H_FLAG or N_FLAG))
    or   byte ptr esi[FREG], C_FLAG      { Set carry flag }
  @RRCAExit:
    jmp  @Exit

  @IY_DJNZ_Func:
    dec  byte ptr esi[BREG]
    jz   @DJNZExit

    mov  bx, word ptr esi[PCREG]
    call GetByte
    inc  word ptr esi[PCREG]
    cbw
    add  word ptr esi[PCREG], ax
    jmp  @Exit

  @DJNZExit:
    inc  word ptr esi[PCREG]
    jmp  @Exit

  @IY_LD_DE_WORD_Func:
    mov  bx, word ptr esi[PCREG]  { bx <- PC      }
    call GetByte                 { al <- MEM[PC] }
    xchg ah, al                  { change ah with al }
    inc  bx
    call GetByte                 { al <- MEM[PC+1] }
    xchg ah, al                  { change ah with al, ax <- MEMW[PC] }
    inc  word ptr esi[PCREG]
    inc  word ptr esi[PCREG]      { PC = PC+2: skip word value }
    mov  word ptr esi[DEREG], ax  { DE <- ax }
    jmp  @Exit

  @IY_LD_xDE_A_Func:
    mov  bx, word ptr esi[DEREG]  { bx <- DE}
    mov  al, byte ptr esi[AREG]   { al <- A}
    call PutByte                 { MEM[bx] <- al }
    jmp  @Exit

  @IY_INC_DE_Func:
    inc  word ptr esi[DEREG]
    jmp  @Exit

  @IY_INC_D_Func:
    xor  ebx, ebx
    mov  bl, byte ptr esi[DREG]
    mov  al, byte ptr aIncTable[ebx]
    and  byte ptr esi[FREG], U1FLAG or U2FLAG or C_FLAG   { dont change carry flag } 
    or   byte ptr esi[FREG],al
    inc  byte ptr esi[DREG]
    jmp  @Exit

  @IY_DEC_D_Func:
    xor  ebx, ebx
    mov  bl, byte ptr esi[DREG]
    mov  al, byte ptr aDecTable[ebx]
    and  byte ptr esi[FREG], U1FLAG or U2FLAG or C_FLAG   { dont change carry flag } 
    or   byte ptr esi[FREG],al
    dec  byte ptr esi[DREG]
    jmp  @Exit

  @IY_LD_D_BYTE_Func:
    mov  bx, word ptr esi[PCREG]      { bx <- PC }
    inc  word ptr esi[PCREG]          { skip one byte }
    call GetByte                     { al <- MEM[PC] }
    mov  byte ptr esi[DREG], al       { D <- al }
    jmp  @Exit

  @IY_RLA_Func:
    rcr  byte ptr esi[FREG], 1           {paso el C sp a C pc}
    rcl  byte ptr esi[AREG], 1           {roto a y meto c}
    rcl  byte ptr esi[FREG], 1           {roto F restaurandolo y metiendo el bit salido de A en C sp}
    and  byte ptr esi[FREG], 11101101b   {H N a cero}
    jmp  @Exit

  @IY_JR_Func:
    mov  bx, word ptr esi[PCREG]
    call GetByte
    inc  word ptr esi[PCREG]
    cbw
    add  word ptr esi[PCREG], ax
    jmp  @Exit

  @IY_ADD_HL_DE_Func:
    { clear half, n and carry flags }
    and  byte ptr esi[FREG], ($FF xor (H_FLAG or N_FLAG or C_FLAG))
    mov  ax, word ptr esi[DEREG]
    add  word ptr esi[IYREG] , ax
    jnc  @CarryNotRaised_ADD_IY_DE
    or   byte ptr esi[FREG], C_FLAG      { set C flag }
  @CarryNotRaised_ADD_IY_DE:
    mov  ax, word ptr esi[DEREG]
    xor  ax, word ptr esi[IYREG]
    and  ax, $1000
    jz   @Exit
    or   byte ptr esi[FREG], H_FLAG      { set H Flag }
    jmp  @Exit

  @IY_LD_A_xDE_Func:
    mov  bx, word ptr esi[DEREG]  { bx <- DE}
    call GetByte
    mov  byte ptr esi[AREG], al
    jmp  @Exit

  @IY_DEC_DE_Func:
    dec  word ptr esi[DEREG]
    jmp  @Exit

  @IY_INC_E_Func:
    xor  ebx, ebx
    mov  bl, byte ptr esi[EREG]
    mov  al, byte ptr aIncTable[ebx]
    and  byte ptr esi[FREG], U1FLAG or U2FLAG or C_FLAG   { dont change carry flag } 
    or   byte ptr esi[FREG],al
    inc  byte ptr esi[EREG]
    jmp  @Exit

  @IY_DEC_E_Func:
    xor  ebx, ebx
    mov  bl, byte ptr esi[EREG]
    mov  al, byte ptr aDecTable[ebx]
    and  byte ptr esi[FREG], U1FLAG or U2FLAG or C_FLAG   { dont change carry flag } 
    or   byte ptr esi[FREG],al
    dec  byte ptr esi[EREG]
    jmp  @Exit

  @IY_LD_E_BYTE_Func:
    mov  bx, word ptr esi[PCREG]      { bx <- PC }
    inc  word ptr esi[PCREG]          { skip one byte }
    call GetByte                     { al <- MEM[PC] }
    mov  byte ptr esi[EREG], al       { E <- al }
    jmp  @Exit

  @IY_RRA_Func:
    rcr  byte ptr esi[FREG], 1      {paso el C sp a C pc}
    rcr  byte ptr esi[AREG], 1      {roto a y meto c}
    rcl  byte ptr esi[FREG], 1      {roto F restaurandolo y metiendo el bit salido de A en C sp}
    and  byte ptr esi[FREG], 11101101b  {H N a cero}
    jmp  @Exit

  @IY_JR_NZ_Func:
    test byte ptr esi[FREG], 01000000b
    jnz  @JRNZFalse

    mov  bx, word ptr esi[PCREG]
    call GetByte
    inc  word ptr esi[PCREG]
    cbw
    add  word ptr esi[PCREG], ax
    jmp  @Exit

  @JRNZFalse:
    inc  word ptr esi[PCREG]
    jmp  @Exit

  @IY_LD_HL_WORD_Func:
    mov  bx, word ptr esi[PCREG]  { bx <- PC      }
    call GetByte                 { al <- MEM[PC] }
    xchg ah, al                  { change ah with al }
    inc  bx
    call GetByte                 { al <- MEM[PC+1] }
    xchg ah, al                  { change ah with al, ax <- MEMW[PC] }
    inc  word ptr esi[PCREG]
    inc  word ptr esi[PCREG]      { PC = PC+2: skip word value }
    mov  word ptr esi[IYREG], ax  { IY <- ax }
    jmp  @Exit

  @IY_LD_xWORD_HL_Func:
    mov  bx, word ptr esi[PCREG]
    call GetByte
    xchg ah, al
    inc  bx
    call GetByte
    xchg ah, al                         { ax <- MEMW[PC] }
    inc  word ptr esi[PCREG]
    inc  word ptr esi[PCREG]             { skip two bytes }
    mov  bx, ax
    mov  al, byte ptr esi[IYLREG]
    call PutByte
    inc  bx
    mov  al, byte ptr esi[IYHREG]
    call PutByte
    jmp  @Exit

  @IY_INC_HL_Func:
    inc  word ptr esi[IYREG]
    jmp  @Exit

  @IY_INC_H_Func:
    xor  ebx, ebx
    mov  bl, byte ptr esi[IYHREG]
    mov  al, byte ptr aIncTable[ebx]
    and  byte ptr esi[FREG], U1FLAG or U2FLAG or C_FLAG   { dont change carry flag } 
    or   byte ptr esi[FREG],al
    inc  byte ptr esi[IYHREG]
    jmp  @Exit

  @IY_DEC_H_Func:
    xor  ebx, ebx
    mov  bl, byte ptr esi[IYHREG]
    mov  al, byte ptr aDecTable[ebx]
    and  byte ptr esi[FREG], U1FLAG or U2FLAG or C_FLAG   { dont change carry flag } 
    or   byte ptr esi[FREG],al
    dec  byte ptr esi[IYHREG]
    jmp  @Exit

  @IY_LD_H_BYTE_Func:
    mov  bx, word ptr esi[PCREG]      { bx <- PC }
    inc  word ptr esi[PCREG]          { skip one byte }
    call GetByte                     { al <- MEM[PC] }
    mov  byte ptr esi[IYHREG], al       { IYH <- al }
    jmp  @Exit

  @IY_DAA_Func:
    xor    edx, edx
    mov     dl, byte ptr esi[FREG]
    and     dl, 10011b
    test    dl, 10000b
    jz      @No_Set_3
    or      dl,100b
    and     dl,111b
@No_Set_3:
    shl     dx, 9                  { dx <- dx*512 }
    xor    eax, eax
    mov     al, byte ptr esi[AREG]
    add     ax, ax
    add     ax, dx
    mov     ebx, eax
    mov     al, byte ptr aDAATable[ebx+1]
    mov     byte ptr esi[FREG], al
    mov     al, byte ptr aDAATable[ebx]
    mov     byte ptr esi[AREG], al
    jmp  @Exit

  @IY_JR_Z_Func:
    test byte ptr esi[FREG], 01000000b
    jz   @JRZFalse 

    mov  bx, word ptr esi[PCREG]
    call GetByte
    inc  word ptr esi[PCREG]
    cbw
    add  word ptr esi[PCREG], ax
    jmp  @Exit

  @JRZFalse:
    inc  word ptr esi[PCREG]
    jmp  @Exit

  @IY_ADD_HL_HL_Func:
    { clear half, n and carry flags }
    and  byte ptr esi[FREG], ($FF xor (H_FLAG or N_FLAG or C_FLAG))
    mov  ax, word ptr esi[IYREG]
    add  word ptr esi[IYREG] , ax
    jnc  @CarryNotRaised_ADD_IY_IY
    or   byte ptr esi[FREG], C_FLAG      { set C flag }
  @CarryNotRaised_ADD_IY_IY:
    mov  ax, word ptr esi[IYREG]
    xor  ax, word ptr esi[IYREG]
    and  ax, $1000
    jz   @Exit
    or   byte ptr esi[FREG], H_FLAG      { set H Flag }
    jmp  @Exit

  @IY_LD_HL_xWORD_Func:
    mov  bx, word ptr esi[PCREG]
    call GetByte
    xchg ah, al
    inc  bx
    call GetByte
    xchg ah, al
    inc  word ptr esi[PCREG]
    inc  word ptr esi[PCREG]
    mov  bx, ax
    call GetByte
    mov  byte ptr esi[IYLREG], al
    inc  bx
    call GetByte
    mov  byte ptr esi[IYHREG], al
    jmp  @Exit

  @IY_DEC_HL_Func:
    dec  word ptr esi[IYREG]
    jmp  @Exit

  @IY_INC_L_Func:
    xor  ebx, ebx
    mov  bl, byte ptr esi[IYLREG]
    mov  al, byte ptr aIncTable[ebx]
    and  byte ptr esi[FREG], U1FLAG or U2FLAG or C_FLAG   { dont change carry flag } 
    or   byte ptr esi[FREG],al
    inc  byte ptr esi[IYLREG]
    jmp  @Exit

  @IY_DEC_L_Func:
    xor  ebx, ebx
    mov  bl, byte ptr esi[IYLREG]
    mov  al, byte ptr aDecTable[ebx]
    and  byte ptr esi[FREG], U1FLAG or U2FLAG or C_FLAG   { dont change carry flag } 
    or   byte ptr esi[FREG],al
    dec  byte ptr esi[IYLREG]
    jmp  @Exit

  @IY_LD_L_BYTE_Func:
    mov  bx, word ptr esi[PCREG]      { bx <- PC }
    inc  word ptr esi[PCREG]          { skip one byte }
    call GetByte                     { al <- MEM[PC] }
    mov  byte ptr esi[IYLREG], al       { IYL <- al }
    jmp  @Exit

  @IY_CPL_Func:
    xor  byte ptr esi[AREG], $FF
    or   byte ptr esi[FREG], H_FLAG or N_FLAG
    jmp  @Exit

  @IY_JR_NC_Func:
    test byte ptr esi[FREG], 00000001b
    jnz  @JRNCFalse

    mov  bx, word ptr esi[PCREG]
    call GetByte
    inc  word ptr esi[PCREG]
    cbw
    add  word ptr esi[PCREG], ax
    jmp  @Exit

  @JRNCFalse:
    inc  word ptr esi[PCREG]
    jmp  @Exit

  @IY_LD_SP_WORD_Func:
    mov  bx, word ptr esi[PCREG]  { bx <- PC      }
    call GetByte                 { al <- MEM[PC] }
    xchg ah, al                  { change ah with al }
    inc  bx
    call GetByte                 { al <- MEM[PC+1] }
    xchg ah, al                  { change ah with al, ax <- MEMW[PC] }
    inc  word ptr esi[PCREG]
    inc  word ptr esi[PCREG]      { PC = PC+2: skip word value }
    mov  word ptr esi[SPREG], ax  { SP <- ax }
    jmp  @Exit

  @IY_LD_xWORD_A_Func:
    mov  bx, word ptr esi[PCREG]
    call GetByte
    xchg ah, al
    inc  bx
    call GetByte
    xchg ah, al
    inc  word ptr esi[PCREG]
    inc  word ptr esi[PCREG]
    mov  bx, ax
    mov  al, byte ptr esi[AREG]
    call PutByte
    jmp  @Exit

  @IY_INC_SP_Func:
    inc  word ptr esi[SPREG]
    jmp  @Exit

  @IY_INC_xHL_Func:
    mov  bx, word ptr esi[PCREG]
    inc  word ptr esi[PCREG]
    call GetByte
    cbw
    mov  bx, word ptr esi[IYREG]
    add  bx, ax
    push bx
    call GetByte
    xor  ebx, ebx
    mov  bl, al
    push ax
    mov  al, byte ptr aIncTable[ebx]
    and  byte ptr esi[FREG], U1FLAG or U2FLAG or C_FLAG   { dont change carry flag } 
    or   byte ptr esi[FREG],al
    pop  ax
    pop  bx
    inc  al
    call PutByte
    jmp  @Exit

  @IY_DEC_xHL_Func:
    mov  bx, word ptr esi[PCREG]
    inc  word ptr esi[PCREG]
    call GetByte
    cbw
    mov  bx, word ptr esi[IYREG]
    add  bx, ax
    push bx
    call GetByte
    xor  ebx, ebx
    mov  bl, al
    push ax
    mov  al, byte ptr aDecTable[ebx]
    and  byte ptr esi[FREG], U1FLAG or U2FLAG or C_FLAG   { dont change carry flag } 
    or   byte ptr esi[FREG],al
    pop  ax
    pop  bx
    dec  al
    call PutByte
    jmp  @Exit

  @IY_LD_xHL_BYTE_Func:
    mov  bx, word ptr esi[PCREG]
    inc  word ptr esi[PCREG]
    call GetByte
    cbw
    mov  bx, word ptr esi[IYREG]  { bx <- IY}
    add  bx, ax
    push bx
    mov  bx, word ptr esi[PCREG]
    inc  word ptr esi[PCREG]
    call GetByte
    pop  bx
    call PutByte
    jmp  @Exit

  @IY_SCF_Func:
    { Clear half and n flags }
    and  byte ptr esi[FREG], ($FF xor (H_FLAG or N_FLAG))
    or   byte ptr esi[FREG], C_FLAG      { Set carry flag }
    jmp  @Exit

  @IY_JR_C_Func:
    test byte ptr esi[FREG], 00000001b
    jz   @JRCFalse

    mov  bx, word ptr esi[PCREG]
    call GetByte
    inc  word ptr esi[PCREG]
    cbw
    add  word ptr esi[PCREG], ax
    jmp  @Exit

  @JRCFalse:
    inc  word ptr esi[PCREG]
    jmp  @Exit

  @IY_ADD_HL_SP_Func:
    { clear half, n and carry flags }
    and  byte ptr esi[FREG], ($FF xor (H_FLAG or N_FLAG or C_FLAG))
    mov  ax, word ptr esi[SPREG]
    add  word ptr esi[IYREG] , ax
    jnc  @CarryNotRaised_ADD_IY_SP
    or   byte ptr esi[FREG], C_FLAG      { set C flag }
  @CarryNotRaised_ADD_IY_SP:
    mov  ax, word ptr esi[SPREG]
    xor  ax, word ptr esi[IYREG]
    and  ax, $1000
    jz   @Exit
    or   byte ptr esi[FREG], H_FLAG      { set H Flag }
    jmp  @Exit

  @IY_LD_A_xWORD_Func:
    mov  bx, word ptr esi[PCREG]
    call GetByte
    xchg ah, al
    inc  bx
    call GetByte
    xchg ah, al
    inc  word ptr esi[PCREG]
    inc  word ptr esi[PCREG]
    mov  bx, ax
    call GetByte
    mov  byte ptr esi[AREG], al
    jmp  @Exit

  @IY_DEC_SP_Func:
    dec  word ptr esi[SPREG]
    jmp  @Exit

  @IY_INC_A_Func:
    xor  ebx, ebx
    mov  bl, byte ptr esi[AREG]
    mov  al, byte ptr aIncTable[ebx]
    and  byte ptr esi[FREG], U1FLAG or U2FLAG or C_FLAG   { dont change carry flag } 
    or   byte ptr esi[FREG],al
    inc  byte ptr esi[AREG]
    jmp  @Exit

  @IY_DEC_A_Func:
    xor  ebx, ebx
    mov  bl, byte ptr esi[AREG]
    mov  al, byte ptr aDecTable[ebx]
    and  byte ptr esi[FREG], U1FLAG or U2FLAG or C_FLAG   { dont change carry flag } 
    or   byte ptr esi[FREG],al
    dec  byte ptr esi[AREG]
    jmp  @Exit

  @IY_LD_A_BYTE_Func:
    mov  bx, word ptr esi[PCREG]      { bx <- PC }
    inc  word ptr esi[PCREG]          { skip one byte }
    call GetByte                     { al <- MEM[PC] }
    mov  byte ptr esi[AREG], al       { A <- al }
    jmp  @Exit

  @IY_CCF_Func:
    test byte ptr esi[FREG], C_FLAG      { test carryflag }
    jz   @CarryNotRaised
    or   byte ptr esi[FREG], H_FLAG      { Set half flag }
    { reset n and carry flags }
    and  byte ptr esi[FREG], ($FF xor (N_FLAG or C_FLAG))
    jmp  @CCFExit
  @CarryNotRaised:
    { reset n and h flags }
    and  byte ptr esi[FREG], ($FF xor (N_FLAG or H_FLAG))
    or   byte ptr esi[FREG], C_FLAG      { Set carry flag }
  @CCFExit:
    jmp  @Exit

  @IY_LD_B_B_Func:
    mov  al, byte ptr esi[BREG]
    mov  byte ptr esi[BREG], al
    jmp  @Exit

  @IY_LD_B_C_Func:
    mov  al, byte ptr esi[CREG]
    mov  byte ptr esi[BREG], al
    jmp  @Exit

  @IY_LD_B_D_Func:
    mov  al, byte ptr esi[DREG]
    mov  byte ptr esi[BREG], al
    jmp  @Exit

  @IY_LD_B_E_Func:
    mov  al, byte ptr esi[EREG]
    mov  byte ptr esi[BREG], al
    jmp  @Exit

  @IY_LD_B_H_Func:
    mov  al, byte ptr esi[IYHREG]
    mov  byte ptr esi[BREG], al
    jmp  @Exit

  @IY_LD_B_L_Func:
    mov  al, byte ptr esi[IYLREG]
    mov  byte ptr esi[BREG], al
    jmp  @Exit

  @IY_LD_B_xHL_Func:
    mov  bx, word ptr esi[PCREG]
    inc  word ptr esi[PCREG]
    call GetByte
    cbw
    mov  bx, word ptr esi[IYREG]  { bx <- IY}
    add  bx, ax
    call GetByte
    mov  byte ptr esi[BREG], al
    jmp  @Exit

  @IY_LD_B_A_Func:
    mov  al, byte ptr esi[AREG]
    mov  byte ptr esi[BREG], al
    jmp  @Exit

  @IY_LD_C_B_Func:
    mov  al, byte ptr esi[BREG]
    mov  byte ptr esi[CREG], al
    jmp  @Exit

  @IY_LD_C_C_Func:
    mov  al, byte ptr esi[CREG]
    mov  byte ptr esi[CREG], al
    jmp  @Exit

  @IY_LD_C_D_Func:
    mov  al, byte ptr esi[DREG]
    mov  byte ptr esi[CREG], al
    jmp  @Exit

  @IY_LD_C_E_Func:
    mov  al, byte ptr esi[EREG]
    mov  byte ptr esi[CREG], al
    jmp  @Exit

  @IY_LD_C_H_Func:
    mov  al, byte ptr esi[IYHREG]
    mov  byte ptr esi[CREG], al
    jmp  @Exit

  @IY_LD_C_L_Func:
    mov  al, byte ptr esi[IYLREG]
    mov  byte ptr esi[CREG], al
    jmp  @Exit

  @IY_LD_C_xHL_Func:
    mov  bx, word ptr esi[PCREG]
    inc  word ptr esi[PCREG]
    call GetByte
    cbw
    mov  bx, word ptr esi[IYREG]  { bx <- IY}
    add  bx, ax
    call GetByte
    mov  byte ptr esi[CREG], al
    jmp  @Exit

  @IY_LD_C_A_Func:
    mov  al, byte ptr esi[AREG]
    mov  byte ptr esi[CREG], al
    jmp  @Exit

  @IY_LD_D_B_Func:
    mov  al, byte ptr esi[BREG]
    mov  byte ptr esi[DREG], al
    jmp  @Exit

  @IY_LD_D_C_Func:
    mov  al, byte ptr esi[CREG]
    mov  byte ptr esi[DREG], al
    jmp  @Exit

  @IY_LD_D_D_Func:
    mov  al, byte ptr esi[DREG]
    mov  byte ptr esi[DREG], al
    jmp  @Exit

  @IY_LD_D_E_Func:
    mov  al, byte ptr esi[EREG]
    mov  byte ptr esi[DREG], al
    jmp  @Exit

  @IY_LD_D_H_Func:
    mov  al, byte ptr esi[IYHREG]
    mov  byte ptr esi[DREG], al
    jmp  @Exit

  @IY_LD_D_L_Func:
    mov  al, byte ptr esi[IYLREG]
    mov  byte ptr esi[DREG], al
    jmp  @Exit

  @IY_LD_D_xHL_Func:
    mov  bx, word ptr esi[PCREG]
    inc  word ptr esi[PCREG]
    call GetByte
    cbw
    mov  bx, word ptr esi[IYREG]  { bx <- IY}
    add  bx, ax
    call GetByte
    mov  byte ptr esi[DREG], al
    jmp  @Exit

  @IY_LD_D_A_Func:
    mov  al, byte ptr esi[AREG]
    mov  byte ptr esi[DREG], al
    jmp  @Exit

  @IY_LD_E_B_Func:
    mov  al, byte ptr esi[BREG]
    mov  byte ptr esi[EREG], al
    jmp  @Exit

  @IY_LD_E_C_Func:
    mov  al, byte ptr esi[CREG]
    mov  byte ptr esi[EREG], al
    jmp  @Exit

  @IY_LD_E_D_Func:
    mov  al, byte ptr esi[DREG]
    mov  byte ptr esi[EREG], al
    jmp  @Exit

  @IY_LD_E_E_Func:
    mov  al, byte ptr esi[EREG]
    mov  byte ptr esi[EREG], al
    jmp  @Exit

  @IY_LD_E_H_Func:
    mov  al, byte ptr esi[IYHREG]
    mov  byte ptr esi[EREG], al
    jmp  @Exit

  @IY_LD_E_L_Func:
    mov  al, byte ptr esi[IYLREG]
    mov  byte ptr esi[EREG], al
    jmp  @Exit

  @IY_LD_E_xHL_Func:
    mov  bx, word ptr esi[PCREG]
    inc  word ptr esi[PCREG]
    call GetByte
    cbw
    mov  bx, word ptr esi[IYREG]  { bx <- IY}
    add  bx, ax
    call GetByte
    mov  byte ptr esi[EREG], al
    jmp  @Exit

  @IY_LD_E_A_Func:
    mov  al, byte ptr esi[AREG]
    mov  byte ptr esi[EREG], al
    jmp  @Exit

  @IY_LD_H_B_Func:
    mov  al, byte ptr esi[BREG]
    mov  byte ptr esi[IYHREG], al
    jmp  @Exit

  @IY_LD_H_C_Func:
    mov  al, byte ptr esi[CREG]
    mov  byte ptr esi[IYHREG], al
    jmp  @Exit

  @IY_LD_H_D_Func:
    mov  al, byte ptr esi[DREG]
    mov  byte ptr esi[IYHREG], al
    jmp  @Exit

  @IY_LD_H_E_Func:
    mov  al, byte ptr esi[EREG]
    mov  byte ptr esi[IYHREG], al
    jmp  @Exit

  @IY_LD_H_H_Func:
    mov  al, byte ptr esi[IYHREG]
    mov  byte ptr esi[IYHREG], al
    jmp  @Exit

  @IY_LD_H_L_Func:
    mov  al, byte ptr esi[IYLREG]
    mov  byte ptr esi[IYHREG], al
    jmp  @Exit

  @IY_LD_H_xHL_Func:
    mov  bx, word ptr esi[PCREG]
    inc  word ptr esi[PCREG]
    call GetByte
    cbw
    mov  bx, word ptr esi[IYREG]  { bx <- IY}
    add  bx, ax
    call GetByte
    mov  byte ptr esi[HREG], al
    jmp  @Exit

  @IY_LD_H_A_Func:
    mov  al, byte ptr esi[AREG]
    mov  byte ptr esi[IYHREG], al
    jmp  @Exit

  @IY_LD_L_B_Func:
    mov  al, byte ptr esi[BREG]
    mov  byte ptr esi[IYLREG], al
    jmp  @Exit

  @IY_LD_L_C_Func:
    mov  al, byte ptr esi[CREG]
    mov  byte ptr esi[IYLREG], al
    jmp  @Exit

  @IY_LD_L_D_Func:
    mov  al, byte ptr esi[DREG]
    mov  byte ptr esi[IYLREG], al
    jmp  @Exit

  @IY_LD_L_E_Func:
    mov  al, byte ptr esi[EREG]
    mov  byte ptr esi[IYLREG], al
    jmp  @Exit

  @IY_LD_L_H_Func:
    mov  al, byte ptr esi[IYHREG]
    mov  byte ptr esi[IYLREG], al
    jmp  @Exit

  @IY_LD_L_L_Func:
    mov  al, byte ptr esi[IYLREG]
    mov  byte ptr esi[IYLREG], al
    jmp  @Exit

  @IY_LD_L_xHL_Func:
    mov  bx, word ptr esi[PCREG]
    inc  word ptr esi[PCREG]
    call GetByte
    cbw
    mov  bx, word ptr esi[IYREG]  { bx <- IY}
    add  bx, ax
    call GetByte
    mov  byte ptr esi[LREG], al
    jmp  @Exit

  @IY_LD_L_A_Func:
    mov  al, byte ptr esi[AREG]
    mov  byte ptr esi[IYLREG], al
    jmp  @Exit

  @IY_LD_xHL_B_Func:
    mov  bx, word ptr esi[PCREG]
    inc  word ptr esi[PCREG]
    call GetByte
    cbw
    mov  bx, word ptr esi[IYREG]  { bx <- IY}
    add  bx, ax
    mov  al, byte ptr esi[BREG]   { al <- B}
    call PutByte                 { MEM[bx] <- al }
    jmp  @Exit

  @IY_LD_xHL_C_Func:
    mov  bx, word ptr esi[PCREG]
    inc  word ptr esi[PCREG]
    call GetByte
    cbw
    mov  bx, word ptr esi[IYREG]  { bx <- IY}
    add  bx, ax
    mov  al, byte ptr esi[CREG]   { al <- C}
    call PutByte                 { MEM[bx] <- al }
    jmp  @Exit

  @IY_LD_xHL_D_Func:
    mov  bx, word ptr esi[PCREG]
    inc  word ptr esi[PCREG]
    call GetByte
    cbw
    mov  bx, word ptr esi[IYREG]  { bx <- IY}
    add  bx, ax
    mov  al, byte ptr esi[DREG]   { al <- D}
    call PutByte                 { MEM[bx] <- al }
    jmp  @Exit

  @IY_LD_xHL_E_Func:
    mov  bx, word ptr esi[PCREG]
    inc  word ptr esi[PCREG]
    call GetByte
    cbw
    mov  bx, word ptr esi[IYREG]  { bx <- IY}
    add  bx, ax
    mov  al, byte ptr esi[EREG]   { al <- E}
    call PutByte                 { MEM[bx] <- al }
    jmp  @Exit

  @IY_LD_xHL_H_Func:
    mov  bx, word ptr esi[PCREG]
    inc  word ptr esi[PCREG]
    call GetByte
    cbw
    mov  bx, word ptr esi[IYREG]  { bx <- IY}
    add  bx, ax
    mov  al, byte ptr esi[HREG]   { al <- H}
    call PutByte                 { MEM[bx] <- al }
    jmp  @Exit

  @IY_LD_xHL_L_Func:
    mov  bx, word ptr esi[PCREG]
    inc  word ptr esi[PCREG]
    call GetByte
    cbw
    mov  bx, word ptr esi[IYREG]  { bx <- IY}
    add  bx, ax
    mov  al, byte ptr esi[LREG]   { al <- L}
    call PutByte                 { MEM[bx] <- al }
    jmp  @Exit

  @IY_HALT_Func:
    dec  word ptr esi[PCREG]
    mov  byte ptr esi[HALTED], 1
    jmp  @Exit

  @IY_LD_xHL_A_Func:
    mov  bx, word ptr esi[PCREG]
    inc  word ptr esi[PCREG]
    call GetByte
    cbw
    mov  bx, word ptr esi[IYREG]  { bx <- IY}
    add  bx, ax
    mov  al, byte ptr esi[AREG]   { al <- A}
    call PutByte                 { MEM[bx] <- al }
    jmp  @Exit

  @IY_LD_A_B_Func:
    mov  al, byte ptr esi[BREG]
    mov  byte ptr esi[AREG], al
    jmp  @Exit

  @IY_LD_A_C_Func:
    mov  al, byte ptr esi[CREG]
    mov  byte ptr esi[AREG], al
    jmp  @Exit

  @IY_LD_A_D_Func:
    mov  al, byte ptr esi[DREG]
    mov  byte ptr esi[AREG], al
    jmp  @Exit

  @IY_LD_A_E_Func:
    mov  al, byte ptr esi[EREG]
    mov  byte ptr esi[AREG], al
    jmp  @Exit

  @IY_LD_A_H_Func:
    mov  al, byte ptr esi[IYHREG]
    mov  byte ptr esi[AREG], al
    jmp  @Exit

  @IY_LD_A_L_Func:
    mov  al, byte ptr esi[IYLREG]
    mov  byte ptr esi[AREG], al
    jmp  @Exit

  @IY_LD_A_xHL_Func:
    mov  bx, word ptr esi[PCREG]
    inc  word ptr esi[PCREG]
    call GetByte
    cbw
    mov  bx, word ptr esi[IYREG]  { bx <- IY}
    add  bx, ax
    call GetByte
    mov  byte ptr esi[AREG], al
    jmp  @Exit

  @IY_LD_A_A_Func:
    mov  al, byte ptr esi[AREG]
    mov  byte ptr esi[AREG], al
    jmp  @Exit

  @IY_ADD_B_Func:
    mov  al, byte ptr esi[BREG]
    add  byte ptr esi[AREG], al
    lahf
    jo   @ADD_BOverflow
  {Sin overflow}
    and  ah, 11111001b    { Overflow y N a 0}
    mov  byte ptr esi[FREG], ah
    jmp  @ADD_BExit
  @ADD_BOverflow:
    and  ah, 11111101b    { N a 0}
    or   ah, 00000100b    { Overflow a 1}
    mov  byte ptr esi[FREG], ah
  @ADD_BExit:
    jmp  @Exit

  @IY_ADD_C_Func:
    mov  al, byte ptr esi[CREG]
    add  byte ptr esi[AREG], al
    lahf
    jo   @ADD_COverflow
  {Sin overflow}
    and  ah, 11111001b    { Overflow y N a 0}
    mov  byte ptr esi[FREG], ah
    jmp  @ADD_CExit
  @ADD_COverflow:
    and  ah, 11111101b    { N a 0}
    or   ah, 00000100b    { Overflow a 1}
    mov  byte ptr esi[FREG], ah
  @ADD_CExit:
    jmp  @Exit

  @IY_ADD_D_Func:
    mov  al, byte ptr esi[DREG]
    add  byte ptr esi[AREG], al
    lahf
    jo   @ADD_DOverflow
  {Sin overflow}
    and  ah, 11111001b    { Overflow y N a 0}
    mov  byte ptr esi[FREG], ah
    jmp  @ADD_DExit
  @ADD_DOverflow:
    and  ah, 11111101b    { N a 0}
    or   ah, 00000100b    { Overflow a 1}
    mov  byte ptr esi[FREG], ah
  @ADD_DExit:
    jmp  @Exit

  @IY_ADD_E_Func:
    mov  al, byte ptr esi[EREG]
    add  byte ptr esi[AREG], al
    lahf
    jo   @ADD_EOverflow
  {Sin overflow}
    and  ah, 11111001b    { Overflow y N a 0}
    mov  byte ptr esi[FREG], ah
    jmp  @ADD_EExit
  @ADD_EOverflow:
    and  ah, 11111101b    { N a 0}
    or   ah, 00000100b    { Overflow a 1}
    mov  byte ptr esi[FREG], ah
  @ADD_EExit:
    jmp  @Exit

  @IY_ADD_H_Func:
    mov  al, byte ptr esi[HREG]
    add  byte ptr esi[AREG], al
    lahf
    jo   @ADD_HOverflow
  {Sin overflow}
    and  ah, 11111001b    { Overflow y N a 0}
    mov  byte ptr esi[FREG], ah
    jmp  @ADD_HExit
  @ADD_HOverflow:
    and  ah, 11111101b    { N a 0}
    or   ah, 00000100b    { Overflow a 1}
    mov  byte ptr esi[FREG], ah
  @ADD_HExit:
    jmp  @Exit

  @IY_ADD_L_Func:
    mov  al, byte ptr esi[LREG]
    add  byte ptr esi[AREG], al
    lahf
    jo   @ADD_LOverflow
  {Sin overflow}
    and  ah, 11111001b    { Overflow y N a 0}
    mov  byte ptr esi[FREG], ah
    jmp  @ADD_LExit
  @ADD_LOverflow:
    and  ah, 11111101b    { N a 0}
    or   ah, 00000100b    { Overflow a 1}
    mov  byte ptr esi[FREG], ah
  @ADD_LExit:
    jmp  @Exit

  @IY_ADD_xHL_Func:
    mov  bx, word ptr esi[PCREG]
    inc  word ptr esi[PCREG]
    call GetByte
    cbw
    mov  bx, word ptr esi[IYREG]
    add  bx, ax
    call GetByte
    add  byte ptr esi[AREG], al
    lahf
    jo   @ADD_xHLOverflow
  {Sin overflow}
    and  ah, 11111001b    { Overflow y N a 0}
    mov  byte ptr esi[FREG], ah
    jmp  @ADD_xHLExit
  @ADD_xHLOverflow:
    and  ah, 11111101b    { N a 0}
    or   ah, 00000100b    { Overflow a 1}
    mov  byte ptr esi[FREG], ah
  @ADD_xHLExit:
    jmp  @Exit

  @IY_ADD_A_Func:
    mov  al, byte ptr esi[AREG]
    add  byte ptr esi[AREG], al
    lahf
    jo   @ADD_AOverflow
  {Sin overflow}
    and  ah, 11111001b    { Overflow y N a 0}
    mov  byte ptr esi[FREG], ah
    jmp  @ADD_AExit
  @ADD_AOverflow:
    and  ah, 11111101b    { N a 0}
    or   ah, 00000100b    { Overflow a 1}
    mov  byte ptr esi[FREG], ah
  @ADD_AExit:
    jmp  @Exit

  @IY_ADC_B_Func:
    mov  al, byte ptr esi[BREG]
    mov  ah, byte ptr esi[FREG]
    sahf
    adc  byte ptr esi[AREG], al
    lahf
    jo   @ADC_BOverflow
    and  ah, 11111001b    { Overflow y N a 0}
    mov  byte ptr esi[FREG], ah
    jmp  @ADC_BExit
  @ADC_BOverflow:
    and  ah, 11111101b    { N a 0}
    or   ah, 00000100b    { Overflow a 1}
    mov  byte ptr esi[FREG], ah
  @ADC_BExit:
    jmp  @Exit

  @IY_ADC_C_Func:
    mov  al, byte ptr esi[CREG]
    mov  ah, byte ptr esi[FREG]
    sahf
    adc  byte ptr esi[AREG], al
    lahf
    jo   @ADC_COverflow
    and  ah, 11111001b    { Overflow y N a 0}
    mov  byte ptr esi[FREG], ah
    jmp  @ADC_CExit
  @ADC_COverflow:
    and  ah, 11111101b    { N a 0}
    or   ah, 00000100b    { Overflow a 1}
    mov  byte ptr esi[FREG], ah
  @ADC_CExit:
    jmp  @Exit

  @IY_ADC_D_Func:
    mov  al, byte ptr esi[DREG]
    mov  ah, byte ptr esi[FREG]
    sahf
    adc  byte ptr esi[AREG], al
    lahf
    jo   @ADC_DOverflow
    and  ah, 11111001b    { Overflow y N a 0}
    mov  byte ptr esi[FREG], ah
    jmp  @ADC_DExit
  @ADC_DOverflow:
    and  ah, 11111101b    { N a 0}
    or   ah, 00000100b    { Overflow a 1}
    mov  byte ptr esi[FREG], ah
  @ADC_DExit:
    jmp  @Exit

  @IY_ADC_E_Func:
    mov  al, byte ptr esi[EREG]
    mov  ah, byte ptr esi[FREG]
    sahf
    adc  byte ptr esi[AREG], al
    lahf
    jo   @ADC_EOverflow
    and  ah, 11111001b    { Overflow y N a 0}
    mov  byte ptr esi[FREG], ah
    jmp  @ADC_EExit
  @ADC_EOverflow:
    and  ah, 11111101b    { N a 0}
    or   ah, 00000100b    { Overflow a 1}
    mov  byte ptr esi[FREG], ah
  @ADC_EExit:
    jmp  @Exit

  @IY_ADC_H_Func:
    mov  al, byte ptr esi[HREG]
    mov  ah, byte ptr esi[FREG]
    sahf
    adc  byte ptr esi[AREG], al
    lahf
    jo   @ADC_HOverflow
    and  ah, 11111001b    { Overflow y N a 0}
    mov  byte ptr esi[FREG], ah
    jmp  @ADC_HExit
  @ADC_HOverflow:
    and  ah, 11111101b    { N a 0}
    or   ah, 00000100b    { Overflow a 1}
    mov  byte ptr esi[FREG], ah
  @ADC_HExit:
    jmp  @Exit

  @IY_ADC_L_Func:
    mov  al, byte ptr esi[LREG]
    mov  ah, byte ptr esi[FREG]
    sahf
    adc  byte ptr esi[AREG], al
    lahf
    jo   @ADC_LOverflow
    and  ah, 11111001b    { Overflow y N a 0}
    mov  byte ptr esi[FREG], ah
    jmp  @ADC_LExit
  @ADC_LOverflow:
    and  ah, 11111101b    { N a 0}
    or   ah, 00000100b    { Overflow a 1}
    mov  byte ptr esi[FREG], ah
  @ADC_LExit:
    jmp  @Exit

  @IY_ADC_xHL_Func:
    mov  bx, word ptr esi[PCREG]
    inc  word ptr esi[PCREG]
    call GetByte
    inc  word ptr esi[PCREG]
    cbw
    mov  bx, word ptr esi[IYREG]
    add  bx, ax
    call GetByte
    mov  ah, byte ptr esi[FREG]
    sahf
    adc  byte ptr esi[AREG], al
    lahf
    jo   @ADC_xHLOverflow
    and  ah, 11111001b    { Overflow y N a 0}
    mov  byte ptr esi[FREG], ah
    jmp  @ADC_xHLExit
  @ADC_xHLOverflow:
    and  ah, 11111101b    { N a 0}
    or   ah, 00000100b    { Overflow a 1}
    mov  byte ptr esi[FREG], ah
  @ADC_xHLExit:
    jmp  @Exit

  @IY_ADC_A_Func:
    mov  al, byte ptr esi[AREG]
    mov  ah, byte ptr esi[FREG]
    sahf
    adc  byte ptr esi[AREG], al
    lahf
    jo   @ADC_AOverflow
    and  ah, 11111001b    { Overflow y N a 0}
    mov  byte ptr esi[FREG], ah
    jmp  @ADC_AExit
  @ADC_AOverflow:
    and  ah, 11111101b    { N a 0}
    or   ah, 00000100b    { Overflow a 1}
    mov  byte ptr esi[FREG], ah
  @ADC_AExit:
    jmp  @Exit

  @IY_SUB_B_Func:
    mov  al, byte ptr esi[BREG]
    sub  byte ptr esi[AREG], al
    lahf
    jo   @SUB_BOverflow
  {Sin overflow}
    and  ah, 11111011b    { Overflow  a 0}
    or   ah, 00000010b    { N a 1}
    mov  byte ptr esi[FREG], ah
    jmp  @SUB_BExit
  @SUB_BOverflow:
    or   ah, 00000110b    { Overflow y N a 1}
    mov  byte ptr esi[FREG], ah
  @SUB_BExit:
    jmp  @Exit

  @IY_SUB_C_Func:
    mov  al, byte ptr esi[CREG]
    sub  byte ptr esi[AREG], al
    lahf
    jo   @SUB_COverflow
  {Sin overflow}
    and  ah, 11111011b    { Overflow  a 0}
    or   ah, 00000010b    { N a 1}
    mov  byte ptr esi[FREG], ah
    jmp  @SUB_CExit
  @SUB_COverflow:
    or   ah, 00000110b    { Overflow y N a 1}
    mov  byte ptr esi[FREG], ah
  @SUB_CExit:
    jmp  @Exit

  @IY_SUB_D_Func:
    mov  al, byte ptr esi[DREG]
    sub  byte ptr esi[AREG], al
    lahf
    jo   @SUB_DOverflow
  {Sin overflow}
    and  ah, 11111011b    { Overflow  a 0}
    or   ah, 00000010b    { N a 1}
    mov  byte ptr esi[FREG], ah
    jmp  @SUB_DExit
  @SUB_DOverflow:
    or   ah, 00000110b    { Overflow y N a 1}
    mov  byte ptr esi[FREG], ah
  @SUB_DExit:
    jmp  @Exit

  @IY_SUB_E_Func:
    mov  al, byte ptr esi[EREG]
    sub  byte ptr esi[AREG], al
    lahf
    jo   @SUB_EOverflow
  {Sin overflow}
    and  ah, 11111011b    { Overflow  a 0}
    or   ah, 00000010b    { N a 1}
    mov  byte ptr esi[FREG], ah
    jmp  @SUB_EExit
  @SUB_EOverflow:
    or   ah, 00000110b    { Overflow y N a 1}
    mov  byte ptr esi[FREG], ah
  @SUB_EExit:
    jmp  @Exit

  @IY_SUB_H_Func:
    mov  al, byte ptr esi[HREG]
    sub  byte ptr esi[AREG], al
    lahf
    jo   @SUB_HOverflow
  {Sin overflow}
    and  ah, 11111011b    { Overflow  a 0}
    or   ah, 00000010b    { N a 1}
    mov  byte ptr esi[FREG], ah
    jmp  @SUB_HExit
  @SUB_HOverflow:
    or   ah, 00000110b    { Overflow y N a 1}
    mov  byte ptr esi[FREG], ah
  @SUB_HExit:
    jmp  @Exit

  @IY_SUB_L_Func:
    mov  al, byte ptr esi[LREG]
    sub  byte ptr esi[AREG], al
    lahf
    jo   @SUB_LOverflow
  {Sin overflow}
    and  ah, 11111011b    { Overflow  a 0}
    or   ah, 00000010b    { N a 1}
    mov  byte ptr esi[FREG], ah
    jmp  @SUB_LExit
  @SUB_LOverflow:
    or   ah, 00000110b    { Overflow y N a 1}
    mov  byte ptr esi[FREG], ah
  @SUB_LExit:
    jmp  @Exit

  @IY_SUB_xHL_Func:
    mov  bx, word ptr esi[PCREG]
    inc  word ptr esi[PCREG]
    call GetByte
    cbw
    mov  bx, word ptr esi[IYREG]
    add  bx, ax
    call GetByte
    sub  byte ptr esi[AREG], al
    lahf
    jo   @SUB_xHLOverflow
  {Sin overflow}
    and  ah, 11111011b    { Overflow  a 0}
    or   ah, 00000010b    { N a 1}
    mov  byte ptr esi[FREG], ah
    jmp  @SUB_xHLExit
  @SUB_xHLOverflow:
    or   ah, 00000110b    { Overflow y N a 1}
    mov  byte ptr esi[FREG], ah
  @SUB_xHLExit:
    jmp  @Exit

  @IY_SUB_A_Func:
    mov  al, byte ptr esi[AREG]
    sub  byte ptr esi[AREG], al
    lahf
    jo   @SUB_AOverflow
  {Sin overflow}
    and  ah, 11111011b    { Overflow  a 0}
    or   ah, 00000010b    { N a 1}
    mov  byte ptr esi[FREG], ah
    jmp  @SUB_AExit
  @SUB_AOverflow:
    or   ah, 00000110b    { Overflow y N a 1}
    mov  byte ptr esi[FREG], ah
  @SUB_AExit:
    jmp  @Exit

  @IY_SBC_B_Func:
    mov  al, byte ptr esi[BREG]
    ror  byte ptr esi[FREG], 1
    sbb  byte ptr esi[AREG], al
    lahf
    jo   @SBC_BOverflow
  {Sin overflow}
    and  ah, 11111011b    { Overflow  a 0}
    or   ah, 00000010b    { N a 1}
    mov  byte ptr esi[FREG], ah
    jmp  @SBC_BExit
  @SBC_BOverflow:
    or   ah, 00000110b    { Overflow y N a 1}
    mov  byte ptr esi[FREG], ah
  @SBC_BExit:
    jmp  @Exit

  @IY_SBC_C_Func:
    mov  al, byte ptr esi[CREG]
    ror  byte ptr esi[FREG], 1
    sbb  byte ptr esi[AREG], al
    lahf
    jo   @SBC_COverflow
  {Sin overflow}
    and  ah, 11111011b    { Overflow  a 0}
    or   ah, 00000010b    { N a 1}
    mov  byte ptr esi[FREG], ah
    jmp  @SBC_CExit
  @SBC_COverflow:
    or   ah, 00000110b    { Overflow y N a 1}
    mov  byte ptr esi[FREG], ah
  @SBC_CExit:
    jmp  @Exit

  @IY_SBC_D_Func:
    mov  al, byte ptr esi[DREG]
    ror  byte ptr esi[FREG], 1
    sbb  byte ptr esi[AREG], al
    lahf
    jo   @SBC_DOverflow
  {Sin overflow}
    and  ah, 11111011b    { Overflow  a 0}
    or   ah, 00000010b    { N a 1}
    mov  byte ptr esi[FREG], ah
    jmp  @SBC_DExit
  @SBC_DOverflow:
    or   ah, 00000110b    { Overflow y N a 1}
    mov  byte ptr esi[FREG], ah
  @SBC_DExit:
    jmp  @Exit

  @IY_SBC_E_Func:
    mov  al, byte ptr esi[EREG]
    ror  byte ptr esi[FREG], 1
    sbb  byte ptr esi[AREG], al
    lahf
    jo   @SBC_EOverflow
  {Sin overflow}
    and  ah, 11111011b    { Overflow  a 0}
    or   ah, 00000010b    { N a 1}
    mov  byte ptr esi[FREG], ah
    jmp  @SBC_EExit
  @SBC_EOverflow:
    or   ah, 00000110b    { Overflow y N a 1}
    mov  byte ptr esi[FREG], ah
  @SBC_EExit:
    jmp  @Exit

  @IY_SBC_H_Func:
    mov  al, byte ptr esi[HREG]
    ror  byte ptr esi[FREG], 1
    sbb  byte ptr esi[AREG], al
    lahf
    jo   @SBC_HOverflow
  {Sin overflow}
    and  ah, 11111011b    { Overflow  a 0}
    or   ah, 00000010b    { N a 1}
    mov  byte ptr esi[FREG], ah
    jmp  @SBC_HExit
  @SBC_HOverflow:
    or   ah, 00000110b    { Overflow y N a 1}
    mov  byte ptr esi[FREG], ah
  @SBC_HExit:
    jmp  @Exit

  @IY_SBC_L_Func:
    mov  al, byte ptr esi[LREG]
    ror  byte ptr esi[FREG], 1
    sbb  byte ptr esi[AREG], al
    lahf
    jo   @SBC_LOverflow
  {Sin overflow}
    and  ah, 11111011b    { Overflow  a 0}
    or   ah, 00000010b    { N a 1}
    mov  byte ptr esi[FREG], ah
    jmp  @SBC_LExit
  @SBC_LOverflow:
    or   ah, 00000110b    { Overflow y N a 1}
    mov  byte ptr esi[FREG], ah
  @SBC_LExit:
    jmp  @Exit

  @IY_SBC_xHL_Func:
    mov  bx, word ptr esi[PCREG]
    inc  word ptr esi[PCREG]
    call GetByte
    cbw
    mov  bx, word ptr esi[IYREG]
    add  bx, ax
    call GetByte
    ror  byte ptr esi[FREG], 1
    sbb  byte ptr esi[AREG], al
    lahf
    jo   @SBC_xHLOverflow
  {Sin overflow}
    and  ah, 11111011b    { Overflow  a 0}
    or   ah, 00000010b    { N a 1}
    mov  byte ptr esi[FREG], ah
    jmp  @SBC_xHLExit
  @SBC_xHLOverflow:
    or   ah, 00000110b    { Overflow y N a 1}
    mov  byte ptr esi[FREG], ah
  @SBC_xHLExit:
    jmp  @Exit

  @IY_SBC_A_Func:
    mov  al, byte ptr esi[AREG]
    ror  byte ptr esi[FREG], 1
    sbb  byte ptr esi[AREG], al
    lahf
    jo   @SBC_AOverflow
  {Sin overflow}
    and  ah, 11111011b    { Overflow  a 0}
    or   ah, 00000010b    { N a 1}
    mov  byte ptr esi[FREG], ah
    jmp  @SBC_AExit
  @SBC_AOverflow:
    or   ah, 00000110b    { Overflow y N a 1}
    mov  byte ptr esi[FREG], ah
  @SBC_AExit:
    jmp  @Exit

  @IY_AND_B_Func:
    mov  al, byte ptr esi[BREG]
    and  byte ptr esi[AREG], al
    lahf
    and  byte ptr esi[FREG], $FF xor (H_FLAG or N_FLAG or S_FLAG or Z_FLAG or P_FLAG or C_FLAG)
    and  ah, S_FLAG or Z_FLAG or P_FLAG
    or   ah, H_FLAG
    mov  byte ptr esi[FREG], ah
    jmp  @Exit

  @IY_AND_C_Func:
    mov  al, byte ptr esi[CREG]
    and  byte ptr esi[AREG], al
    lahf
    and  byte ptr esi[FREG], $FF xor (H_FLAG or N_FLAG or S_FLAG or Z_FLAG or P_FLAG or C_FLAG)
    and  ah, S_FLAG or Z_FLAG or P_FLAG
    or   ah, H_FLAG
    mov  byte ptr esi[FREG], ah
    jmp  @Exit

  @IY_AND_D_Func:
    mov  al, byte ptr esi[DREG]
    and  byte ptr esi[AREG], al
    lahf
    and  byte ptr esi[FREG], $FF xor (H_FLAG or N_FLAG or S_FLAG or Z_FLAG or P_FLAG or C_FLAG)
    and  ah, S_FLAG or Z_FLAG or P_FLAG
    or   ah, H_FLAG
    mov  byte ptr esi[FREG], ah
    jmp  @Exit

  @IY_AND_E_Func:
    mov  al, byte ptr esi[EREG]
    and  byte ptr esi[AREG], al
    lahf
    and  byte ptr esi[FREG], $FF xor (H_FLAG or N_FLAG or S_FLAG or Z_FLAG or P_FLAG or C_FLAG)
    and  ah, S_FLAG or Z_FLAG or P_FLAG
    or   ah, H_FLAG
    mov  byte ptr esi[FREG], ah
    jmp  @Exit

  @IY_AND_H_Func:
    mov  al, byte ptr esi[HREG]
    and  byte ptr esi[AREG], al
    lahf
    and  byte ptr esi[FREG], $FF xor (H_FLAG or N_FLAG or S_FLAG or Z_FLAG or P_FLAG or C_FLAG)
    and  ah, S_FLAG or Z_FLAG or P_FLAG
    or   ah, H_FLAG
    mov  byte ptr esi[FREG], ah
    jmp  @Exit

  @IY_AND_L_Func:
    mov  al, byte ptr esi[LREG]
    and  byte ptr esi[AREG], al
    lahf
    and  byte ptr esi[FREG], $FF xor (H_FLAG or N_FLAG or S_FLAG or Z_FLAG or P_FLAG or C_FLAG)
    and  ah, S_FLAG or Z_FLAG or P_FLAG
    or   ah, H_FLAG
    mov  byte ptr esi[FREG], ah
    jmp  @Exit

  @IY_AND_xHL_Func:
    mov  bx, word ptr esi[PCREG]
    inc  word ptr esi[PCREG]
    call GetByte
    cbw
    mov  bx, word ptr esi[IYREG]
    add  bx, ax
    call GetByte
    and  byte ptr esi[AREG], al
    lahf
    and  byte ptr esi[FREG], $FF xor (H_FLAG or N_FLAG or S_FLAG or Z_FLAG or P_FLAG or C_FLAG)
    and  ah, S_FLAG or Z_FLAG or P_FLAG
    or   ah, H_FLAG
    mov  byte ptr esi[FREG], ah
    jmp  @Exit

  @IY_AND_A_Func:
    mov  al, byte ptr esi[AREG]
    and  byte ptr esi[AREG], al
    lahf
    and  byte ptr esi[FREG], $FF xor (H_FLAG or N_FLAG or S_FLAG or Z_FLAG or P_FLAG or C_FLAG)
    and  ah, S_FLAG or Z_FLAG or P_FLAG
    or   ah, H_FLAG
    mov  byte ptr esi[FREG], ah
    jmp  @Exit

  @IY_XOR_B_Func:
    mov  al, byte ptr esi[BREG]
    xor  byte ptr esi[AREG], al
    lahf
    and  ah, 11101100b    {H N C a cero}
    mov  byte ptr esi[FREG], ah
    jmp  @Exit

  @IY_XOR_C_Func:
    mov  al, byte ptr esi[CREG]
    xor  byte ptr esi[AREG], al
    lahf
    and  ah, 11101100b    {H N C a cero}
    mov  byte ptr esi[FREG], ah
    jmp  @Exit

  @IY_XOR_D_Func:
    mov  al, byte ptr esi[DREG]
    xor  byte ptr esi[AREG], al
    lahf
    and  ah, 11101100b    {H N C a cero}
    mov  byte ptr esi[FREG], ah
    jmp  @Exit

  @IY_XOR_E_Func:
    mov  al, byte ptr esi[EREG]
    xor  byte ptr esi[AREG], al
    lahf
    and  ah, 11101100b    {H N C a cero}
    mov  byte ptr esi[FREG], ah
    jmp  @Exit

  @IY_XOR_H_Func:
    mov  al, byte ptr esi[HREG]
    xor  byte ptr esi[AREG], al
    lahf
    and  ah, 11101100b    {H N C a cero}
    mov  byte ptr esi[FREG], ah
    jmp  @Exit

  @IY_XOR_L_Func:
    mov  al, byte ptr esi[LREG]
    xor  byte ptr esi[AREG], al
    lahf
    and  ah, 11101100b    {H N C a cero}
    mov  byte ptr esi[FREG], ah
    jmp  @Exit

  @IY_XOR_xHL_Func:
    mov  bx, word ptr esi[PCREG]
    inc  word ptr esi[PCREG]
    call GetByte
    cbw
    mov  bx, word ptr esi[IYREG]
    add  bx, ax
    call GetByte
    xor  byte ptr esi[AREG], al
    lahf
    and  ah, 11101100b    {H N C a cero}
    mov  byte ptr esi[FREG], ah
    jmp  @Exit

  @IY_XOR_A_Func:
    mov  al, byte ptr esi[AREG]
    xor  byte ptr esi[AREG], al
    lahf
    and  ah, 11101100b    {H N C a cero}
    mov  byte ptr esi[FREG], ah
    jmp  @Exit

  @IY_OR_B_Func:
    mov  al, byte ptr esi[BREG]
    or   byte ptr esi[AREG], al
    lahf
    and  ah, 11101100b    {N H C a cero}
    mov  byte ptr esi[FREG], ah
    jmp  @Exit

  @IY_OR_C_Func:
    mov  al, byte ptr esi[CREG]
    or   byte ptr esi[AREG], al
    lahf
    and  ah, 11101100b    {N H C a cero}
    mov  byte ptr esi[FREG], ah
    jmp  @Exit

  @IY_OR_D_Func:
    mov  al, byte ptr esi[DREG]
    or   byte ptr esi[AREG], al
    lahf
    and  ah, 11101100b    {N H C a cero}
    mov  byte ptr esi[FREG], ah
    jmp  @Exit

  @IY_OR_E_Func:
    mov  al, byte ptr esi[EREG]
    or   byte ptr esi[AREG], al
    lahf
    and  ah, 11101100b    {N H C a cero}
    mov  byte ptr esi[FREG], ah
    jmp  @Exit

  @IY_OR_H_Func:
    mov  al, byte ptr esi[HREG]
    or   byte ptr esi[AREG], al
    lahf
    and  ah, 11101100b    {N H C a cero}
    mov  byte ptr esi[FREG], ah
    jmp  @Exit

  @IY_OR_L_Func:
    mov  al, byte ptr esi[LREG]
    or   byte ptr esi[AREG], al
    lahf
    and  ah, 11101100b    {N H C a cero}
    mov  byte ptr esi[FREG], ah
    jmp  @Exit

  @IY_OR_xHL_Func:
    mov  bx, word ptr esi[PCREG]
    inc  word ptr esi[PCREG]
    call GetByte
    cbw
    mov  bx, word ptr esi[IYREG]
    add  bx, ax
    call GetByte
    or   byte ptr esi[AREG], al
    lahf
    and  ah, 11101100b    {N H C a cero}
    mov  byte ptr esi[FREG], ah
    jmp  @Exit

  @IY_OR_A_Func:
    mov  al, byte ptr esi[AREG]
    or   byte ptr esi[AREG], al
    lahf
    and  ah, 11101100b    {N H C a cero}
    mov  byte ptr esi[FREG], ah
    jmp  @Exit

  @IY_CP_B_Func:
    mov  al, byte ptr esi[BREG]
    cmp byte ptr esi[AREG], al
    lahf
    jo   @CP_BOverflow
    {;Sin overflow}
    and  ah,11111011b    {Overflow a 0}
    or   ah,00000010b    {N a 1}
    mov  byte ptr esi[FREG],ah
    jmp  @CP_BExit
  @CP_BOverflow:
    or   ah, 00000110b    {Overflow y N a 1}
    mov  byte ptr esi[FREG], ah
  @CP_BExit:
    jmp  @Exit

  @IY_CP_C_Func:
    mov  al, byte ptr esi[CREG]
    cmp byte ptr esi[AREG], al
    lahf
    jo   @CP_COverflow
    {;Sin overflow}
    and  ah,11111011b    {Overflow a 0}
    or   ah,00000010b    {N a 1}
    mov  byte ptr esi[FREG],ah
    jmp  @CP_CExit
  @CP_COverflow:
    or   ah, 00000110b    {Overflow y N a 1}
    mov  byte ptr esi[FREG], ah
  @CP_CExit:
    jmp  @Exit

  @IY_CP_D_Func:
    mov  al, byte ptr esi[DREG]
    cmp byte ptr esi[AREG], al
    lahf
    jo   @CP_DOverflow
    {;Sin overflow}
    and  ah,11111011b    {Overflow a 0}
    or   ah,00000010b    {N a 1}
    mov  byte ptr esi[FREG],ah
    jmp  @CP_DExit
  @CP_DOverflow:
    or   ah, 00000110b    {Overflow y N a 1}
    mov  byte ptr esi[FREG], ah
  @CP_DExit:
    jmp  @Exit

  @IY_CP_E_Func:
    mov  al, byte ptr esi[EREG]
    cmp byte ptr esi[AREG], al
    lahf
    jo   @CP_EOverflow
    {;Sin overflow}
    and  ah,11111011b    {Overflow a 0}
    or   ah,00000010b    {N a 1}
    mov  byte ptr esi[FREG],ah
    jmp  @CP_EExit
  @CP_EOverflow:
    or   ah, 00000110b    {Overflow y N a 1}
    mov  byte ptr esi[FREG], ah
  @CP_EExit:
    jmp  @Exit

  @IY_CP_H_Func:
    mov  al, byte ptr esi[HREG]
    cmp byte ptr esi[AREG], al
    lahf
    jo   @CP_HOverflow
    {;Sin overflow}
    and  ah,11111011b    {Overflow a 0}
    or   ah,00000010b    {N a 1}
    mov  byte ptr esi[FREG],ah
    jmp  @CP_HExit
  @CP_HOverflow:
    or   ah, 00000110b    {Overflow y N a 1}
    mov  byte ptr esi[FREG], ah
  @CP_HExit:
    jmp  @Exit

  @IY_CP_L_Func:
    mov  al, byte ptr esi[LREG]
    cmp byte ptr esi[AREG], al
    lahf
    jo   @CP_LOverflow
    {;Sin overflow}
    and  ah,11111011b    {Overflow a 0}
    or   ah,00000010b    {N a 1}
    mov  byte ptr esi[FREG],ah
    jmp  @CP_LExit
  @CP_LOverflow:
    or   ah, 00000110b    {Overflow y N a 1}
    mov  byte ptr esi[FREG], ah
  @CP_LExit:
    jmp  @Exit

  @IY_CP_xHL_Func:
    mov  bx, word ptr esi[PCREG]
    inc  word ptr esi[PCREG]
    call GetByte
    cbw
    mov  bx, word ptr esi[IYREG]
    add  bx, ax
    call GetByte
    cmp byte ptr esi[AREG], al
    lahf
    jo   @CP_xHLOverflow
    {;Sin overflow}
    and  ah,11111011b    {Overflow a 0}
    or   ah,00000010b    {N a 1}
    mov  byte ptr esi[FREG],ah
    jmp  @CP_xHLExit
  @CP_xHLOverflow:
    or   ah, 00000110b    {Overflow y N a 1}
    mov  byte ptr esi[FREG], ah
  @CP_xHLExit:
    jmp  @Exit

  @IY_CP_A_Func:
    mov  al, byte ptr esi[AREG]
    cmp byte ptr esi[AREG], al
    lahf
    jo   @CP_AOverflow
    {;Sin overflow}
    and  ah,11111011b    {Overflow a 0}
    or   ah,00000010b    {N a 1}
    mov  byte ptr esi[FREG],ah
    jmp  @CP_AExit
  @CP_AOverflow:
    or   ah, 00000110b    {Overflow y N a 1}
    mov  byte ptr esi[FREG], ah
  @CP_AExit:
    jmp  @Exit

  @IY_RET_NZ_Func:
    test byte ptr esi[FREG], 01000000b
    jnz  @RETNZFalse

    mov  bx, word ptr esi[SPREG]
    call GetByte
    mov  byte ptr esi[PCLREG], al
    inc  word ptr esi[SPREG]

    mov  bx, word ptr esi[SPREG]
    call GetByte
    mov  byte ptr esi[PCHREG], al
    inc  word ptr esi[SPREG]
    jmp  @Exit

  @RETNZFalse:
    jmp  @Exit

  @IY_POP_BC_Func:
    mov  bx, word ptr esi[SPREG]
    call GetByte
    mov  byte ptr esi[CREG], al
    inc  word ptr esi[SPREG]

    mov  bx, word ptr esi[SPREG]
    call GetByte
    mov  byte ptr esi[BREG], al
    inc  word ptr esi[SPREG]
    jmp  @Exit

  @IY_JP_NZ_Func:
    test byte ptr esi[FREG], 01000000b
    jnz  @JPNZFalse

    mov  bx, word ptr esi[PCREG]
    call GetByte
    xchg ah, al
    inc  bx
    call GetByte
    xchg ah, al
    mov  word ptr esi[PCREG], ax
    jmp  @Exit

  @JPNZFalse:
    inc  word ptr esi[PCREG]
    inc  word ptr esi[PCREG]
    jmp  @Exit

  @IY_JP_Func:
    mov  bx, word ptr esi[PCREG]
    call GetByte
    xchg ah, al
    inc  bx
    call GetByte
    xchg ah, al
    mov  word ptr esi[PCREG], ax
    jmp  @Exit

  @IY_CALL_NZ_Func:
    test byte ptr esi[FREG], 01000000b
    jnz  @CALLNZFalse

    mov  bx, word ptr esi[PCREG]
    call GetByte
    xchg ah, al
    inc  bx
    call GetByte
    xchg ah, al
    inc  word ptr esi[PCREG]
    inc  word ptr esi[PCREG]
    push ax
    dec  word ptr esi[SPREG]
    mov  bx, word ptr esi[SPREG]
    mov  al, byte ptr esi[PCHREG]
    call PutByte

    dec  word ptr esi[SPREG]
    mov  bx, word ptr esi[SPREG]
    mov  al, byte ptr esi[PCLREG]
    call PutByte
    pop  ax
    mov  word ptr esi[PCREG], ax
    jmp  @Exit

  @CALLNZFalse:
    inc  word ptr esi[PCREG]
    inc  word ptr esi[PCREG]
    jmp  @Exit

  @IY_PUSH_BC_Func:
    dec  word ptr esi[SPREG]
    mov  bx, word ptr esi[SPREG]
    mov  al, byte ptr esi[BREG]
    call PutByte

    dec  word ptr esi[SPREG]
    mov  bx, word ptr esi[SPREG]
    mov  al, byte ptr esi[CREG]
    call PutByte
    jmp  @Exit

  @IY_ADD_BYTE_Func:
    mov bx, word ptr esi[PCREG]
    call GetByte
    inc  word ptr esi[PCREG]
    add  byte ptr esi[AREG], al
    lahf
    jo   @ADD_BYTEOverflow
  {Sin overflow}
    and  ah, 11111001b    { Overflow y N a 0}
    mov  byte ptr esi[FREG], ah
    jmp  @ADD_BYTEExit
  @ADD_BYTEOverflow:
    and  ah, 11111101b    { N a 0}
    or   ah, 00000100b    { Overflow a 1}
    mov  byte ptr esi[FREG], ah
  @ADD_BYTEExit:
    jmp  @Exit

  @IY_RST00_Func:
    dec  word ptr esi[SPREG]
    mov  bx, word ptr esi[SPREG]
    mov  al, byte ptr esi[PCHREG]
    call PutByte

    dec  word ptr esi[SPREG]
    mov  bx, word ptr esi[SPREG]
    mov  al, byte ptr esi[PCLREG]
    call PutByte

    mov word ptr esi[PCREG], $0000
    jmp  @Exit

  @IY_RET_Z_Func:
    test byte ptr esi[FREG], 01000000b
    jz   @RETZFalse 

    mov  bx, word ptr esi[SPREG]
    call GetByte
    mov  byte ptr esi[PCLREG], al
    inc  word ptr esi[SPREG]

    mov  bx, word ptr esi[SPREG]
    call GetByte
    mov  byte ptr esi[PCHREG], al
    inc  word ptr esi[SPREG]
    jmp  @Exit

  @RETZFalse:
    jmp  @Exit

  @IY_RET_Func:
    mov  bx, word ptr esi[SPREG]
    call GetByte
    mov  byte ptr esi[PCLREG], al
    inc  word ptr esi[SPREG]

    mov  bx, word ptr esi[SPREG]
    call GetByte
    mov  byte ptr esi[PCHREG], al
    inc  word ptr esi[SPREG]
    jmp  @Exit

  @IY_JP_Z_Func:
    test byte ptr esi[FREG], 01000000b
    jz   @JPZFalse 

    mov  bx, word ptr esi[PCREG]
    call GetByte
    xchg ah, al
    inc  bx
    call GetByte
    xchg ah, al
    mov  word ptr esi[PCREG], ax
    jmp  @Exit

  @JPZFalse:
    inc  word ptr esi[PCREG]
    inc  word ptr esi[PCREG]
    jmp  @Exit

  @IY_PFX_CB_Func:
    call OpcodeFDCB
    jmp  @Exit

  @IY_CALL_Z_Func:
    test byte ptr esi[FREG], 01000000b
    jz   @CALLZFalse 

    mov  bx, word ptr esi[PCREG]
    call GetByte
    xchg ah, al
    inc  bx
    call GetByte
    xchg ah, al
    inc  word ptr esi[PCREG]
    inc  word ptr esi[PCREG]
    push ax
    dec  word ptr esi[SPREG]
    mov  bx, word ptr esi[SPREG]
    mov  al, byte ptr esi[PCHREG]
    call PutByte

    dec  word ptr esi[SPREG]
    mov  bx, word ptr esi[SPREG]
    mov  al, byte ptr esi[PCLREG]
    call PutByte
    pop  ax
    mov  word ptr esi[PCREG], ax
    jmp  @Exit

  @CALLZFalse:
    inc  word ptr esi[PCREG]
    inc  word ptr esi[PCREG]
    jmp  @Exit

  @IY_CALL_Func:
    mov  bx, word ptr esi[PCREG]
    call GetByte
    xchg ah, al
    inc  bx
    call GetByte
    xchg ah, al
    inc  word ptr esi[PCREG]
    inc  word ptr esi[PCREG]
    push ax
    dec  word ptr esi[SPREG]
    mov  bx, word ptr esi[SPREG]
    mov  al, byte ptr esi[PCHREG]
    call PutByte

    dec  word ptr esi[SPREG]
    mov  bx, word ptr esi[SPREG]
    mov  al, byte ptr esi[PCLREG]
    call PutByte
    pop  ax
    mov  word ptr esi[PCREG], ax
    jmp  @Exit

  @IY_ADC_BYTE_Func:
    mov bx, word ptr esi[PCREG]
    call GetByte
    inc  word ptr esi[PCREG]
    mov  ah, byte ptr esi[FREG]
    sahf
    adc  byte ptr esi[AREG], al
    lahf
    jo   @ADC_BYTEOverflow
    and  ah, 11111001b    { Overflow y N a 0}
    mov  byte ptr esi[FREG], ah
    jmp  @ADC_BYTEExit
  @ADC_BYTEOverflow:
    and  ah, 11111101b    { N a 0}
    or   ah, 00000100b    { Overflow a 1}
    mov  byte ptr esi[FREG], ah
  @ADC_BYTEExit:
    jmp  @Exit

  @IY_RST08_Func:
    dec  word ptr esi[SPREG]
    mov  bx, word ptr esi[SPREG]
    mov  al, byte ptr esi[PCHREG]
    call PutByte

    dec  word ptr esi[SPREG]
    mov  bx, word ptr esi[SPREG]
    mov  al, byte ptr esi[PCLREG]
    call PutByte

    mov word ptr esi[PCREG], $0008
    jmp  @Exit

  @IY_RET_NC_Func:
    test byte ptr esi[FREG], 00000001b
    jnz  @RETNCFalse

    mov  bx, word ptr esi[SPREG]
    call GetByte
    mov  byte ptr esi[PCLREG], al
    inc  word ptr esi[SPREG]

    mov  bx, word ptr esi[SPREG]
    call GetByte
    mov  byte ptr esi[PCHREG], al
    inc  word ptr esi[SPREG]
    jmp  @Exit

  @RETNCFalse:
    jmp  @Exit

  @IY_POP_DE_Func:
    mov  bx, word ptr esi[SPREG]
    call GetByte
    mov  byte ptr esi[EREG], al
    inc  word ptr esi[SPREG]

    mov  bx, word ptr esi[SPREG]
    call GetByte
    mov  byte ptr esi[DREG], al
    inc  word ptr esi[SPREG]
    jmp  @Exit

  @IY_JP_NC_Func:
    test byte ptr esi[FREG], 00000001b
    jnz  @JPNCFalse

    mov  bx, word ptr esi[PCREG]
    call GetByte
    xchg ah, al
    inc  bx
    call GetByte
    xchg ah, al
    mov  word ptr esi[PCREG], ax
    jmp  @Exit

  @JPNCFalse:
    inc  word ptr esi[PCREG]
    inc  word ptr esi[PCREG]
    jmp  @Exit

  @IY_OUTA_Func:
    mov  bx, word ptr esi[PCREG]
    call GetByte
    mov  bx, ax
    inc  word ptr esi[PCREG]
    mov  al, byte ptr esi[AREG]
    call OutByte
    jmp  @Exit

  @IY_CALL_NC_Func:
    test byte ptr esi[FREG], 00000001b
    jnz  @CALLNCFalse

    mov  bx, word ptr esi[PCREG]
    call GetByte
    xchg ah, al
    inc  bx
    call GetByte
    xchg ah, al
    inc  word ptr esi[PCREG]
    inc  word ptr esi[PCREG]
    push ax
    dec  word ptr esi[SPREG]
    mov  bx, word ptr esi[SPREG]
    mov  al, byte ptr esi[PCHREG]
    call PutByte

    dec  word ptr esi[SPREG]
    mov  bx, word ptr esi[SPREG]
    mov  al, byte ptr esi[PCLREG]
    call PutByte
    pop  ax
    mov  word ptr esi[PCREG], ax
    jmp  @Exit

  @CALLNCFalse:
    inc  word ptr esi[PCREG]
    inc  word ptr esi[PCREG]
    jmp  @Exit

  @IY_PUSH_DE_Func:
    dec  word ptr esi[SPREG]
    mov  bx, word ptr esi[SPREG]
    mov  al, byte ptr esi[DREG]
    call PutByte

    dec  word ptr esi[SPREG]
    mov  bx, word ptr esi[SPREG]
    mov  al, byte ptr esi[EREG]
    call PutByte
    jmp  @Exit

  @IY_SUB_BYTE_Func:
    mov bx, word ptr esi[PCREG]
    call GetByte
    inc  word ptr esi[PCREG]
    sub  byte ptr esi[AREG], al
    lahf
    jo   @SUB_BYTEOverflow
  {Sin overflow}
    and  ah, 11111011b    { Overflow  a 0}
    or   ah, 00000010b    { N a 1}
    mov  byte ptr esi[FREG], ah
    jmp  @SUB_BYTEExit
  @SUB_BYTEOverflow:
    or   ah, 00000110b    { Overflow y N a 1}
    mov  byte ptr esi[FREG], ah
  @SUB_BYTEExit:
    jmp  @Exit

  @IY_RST10_Func:
    dec  word ptr esi[SPREG]
    mov  bx, word ptr esi[SPREG]
    mov  al, byte ptr esi[PCHREG]
    call PutByte

    dec  word ptr esi[SPREG]
    mov  bx, word ptr esi[SPREG]
    mov  al, byte ptr esi[PCLREG]
    call PutByte

    mov word ptr esi[PCREG], $0010
    jmp  @Exit

  @IY_RET_C_Func:
    test byte ptr esi[FREG], 00000001b
    jz   @RETCFalse

    mov  bx, word ptr esi[SPREG]
    call GetByte
    mov  byte ptr esi[PCLREG], al
    inc  word ptr esi[SPREG]

    mov  bx, word ptr esi[SPREG]
    call GetByte
    mov  byte ptr esi[PCHREG], al
    inc  word ptr esi[SPREG]
    jmp  @Exit

  @RETCFalse:
    jmp  @Exit

  @IY_EXX_Func:
    mov  ax, word ptr esi[BCREG]
    mov  bx, word ptr esi[BC1REG]
    mov  word ptr esi[BCREG], bx
    mov  word ptr esi[BC1REG], ax
    mov  ax, word ptr esi[DEREG]
    mov  bx, word ptr esi[DE1REG]
    mov  word ptr esi[DEREG], bx
    mov  word ptr esi[DE1REG], ax
    mov  ax, word ptr esi[HLREG]
    mov  bx, word ptr esi[HL1REG]
    mov  word ptr esi[HLREG], bx
    mov  word ptr esi[HL1REG], ax
    jmp  @Exit

  @IY_JP_C_Func:
    test byte ptr esi[FREG], 00000001b
    jz   @JPCFalse

    mov  bx, word ptr esi[PCREG]
    call GetByte
    xchg ah, al
    inc  bx
    call GetByte
    xchg ah, al
    mov  word ptr esi[PCREG], ax
    jmp  @Exit

  @JPCFalse:
    inc  word ptr esi[PCREG]
    inc  word ptr esi[PCREG]
    jmp  @Exit

  @IY_INA_Func:
    mov  bx, word ptr esi[PCREG]
    call GetByte
    inc  word ptr esi[PCREG]
    call InByte
    mov  byte ptr esi[AREG], al
    jmp  @Exit

  @IY_CALL_C_Func:
    test byte ptr esi[FREG], 00000001b
    jz   @CALLCFalse

    mov  bx, word ptr esi[PCREG]
    call GetByte
    xchg ah, al
    inc  bx
    call GetByte
    xchg ah, al
    inc  word ptr esi[PCREG]
    inc  word ptr esi[PCREG]
    push ax
    dec  word ptr esi[SPREG]
    mov  bx, word ptr esi[SPREG]
    mov  al, byte ptr esi[PCHREG]
    call PutByte

    dec  word ptr esi[SPREG]
    mov  bx, word ptr esi[SPREG]
    mov  al, byte ptr esi[PCLREG]
    call PutByte
    pop  ax
    mov  word ptr esi[PCREG], ax
    jmp  @Exit

  @CALLCFalse:
    inc  word ptr esi[PCREG]
    inc  word ptr esi[PCREG]
    jmp  @Exit

  @IY_PFX_DD_Func:
    call OpcodeDD
    jmp  @Exit

  @IY_SBC_BYTE_Func:
    mov bx, word ptr esi[PCREG]
    call GetByte
    inc  word ptr esi[PCREG]
    ror  byte ptr esi[FREG], 1
    sbb  byte ptr esi[AREG], al
    lahf
    jo   @SBC_BYTEOverflow
  {Sin overflow}
    and  ah, 11111011b    { Overflow  a 0}
    or   ah, 00000010b    { N a 1}
    mov  byte ptr esi[FREG], ah
    jmp  @SBC_BYTEExit
  @SBC_BYTEOverflow:
    or   ah, 00000110b    { Overflow y N a 1}
    mov  byte ptr esi[FREG], ah
  @SBC_BYTEExit:
    jmp  @Exit

  @IY_RST18_Func:
    dec  word ptr esi[SPREG]
    mov  bx, word ptr esi[SPREG]
    mov  al, byte ptr esi[PCHREG]
    call PutByte

    dec  word ptr esi[SPREG]
    mov  bx, word ptr esi[SPREG]
    mov  al, byte ptr esi[PCLREG]
    call PutByte

    mov word ptr esi[PCREG], $0018
    jmp  @Exit

  @IY_RET_PO_Func:
    test byte ptr esi[FREG], 00000100b
    jnz  @RETPOFalse

    mov  bx, word ptr esi[SPREG]
    call GetByte
    mov  byte ptr esi[PCLREG], al
    inc  word ptr esi[SPREG]

    mov  bx, word ptr esi[SPREG]
    call GetByte
    mov  byte ptr esi[PCHREG], al
    inc  word ptr esi[SPREG]
    jmp  @Exit

  @RETPOFalse:
    jmp  @Exit

  @IY_POP_HL_Func:
    mov  bx, word ptr esi[SPREG]
    call GetByte
    mov  byte ptr esi[IYLREG], al
    inc  word ptr esi[SPREG]

    mov  bx, word ptr esi[SPREG]
    call GetByte
    mov  byte ptr esi[IYHREG], al
    inc  word ptr esi[SPREG]
    jmp  @Exit

  @IY_JP_PO_Func:
    test byte ptr esi[FREG], 00000100b
    jnz  @JPPOFalse

    mov  bx, word ptr esi[PCREG]
    call GetByte
    xchg ah, al
    inc  bx
    call GetByte
    xchg ah, al
    mov  word ptr esi[PCREG], ax
    jmp  @Exit

  @JPPOFalse:
    inc  word ptr esi[PCREG]
    inc  word ptr esi[PCREG]
    jmp  @Exit

  @IY_EX_HL_xSP_Func:
    mov  bx, word ptr esi[SPREG]
    call GetByte
    xchg ah, al
    inc  bx
    call GetByte
    xchg ah, al
    mov  dx, word ptr esi[HLREG]
    mov  word ptr esi[HLREG], ax
    mov  bx, word ptr esi[SPREG]
    mov  ax, dx
    call PutByte
    inc  bx
    xchg ah,al
    call PutByte
    jmp  @Exit

  @IY_CALL_PO_Func:
    test byte ptr esi[FREG], 00000100b
    jnz  @CALLPOFalse

    mov  bx, word ptr esi[PCREG]
    call GetByte
    xchg ah, al
    inc  bx
    call GetByte
    xchg ah, al
    inc  word ptr esi[PCREG]
    inc  word ptr esi[PCREG]
    push ax
    dec  word ptr esi[SPREG]
    mov  bx, word ptr esi[SPREG]
    mov  al, byte ptr esi[PCHREG]
    call PutByte

    dec  word ptr esi[SPREG]
    mov  bx, word ptr esi[SPREG]
    mov  al, byte ptr esi[PCLREG]
    call PutByte
    pop  ax
    mov  word ptr esi[PCREG], ax
    jmp  @Exit

  @CALLPOFalse:
    inc  word ptr esi[PCREG]
    inc  word ptr esi[PCREG]
    jmp  @Exit

  @IY_PUSH_HL_Func:
    dec  word ptr esi[SPREG]
    mov  bx, word ptr esi[SPREG]
    mov  al, byte ptr esi[IYHREG]
    call PutByte

    dec  word ptr esi[SPREG]
    mov  bx, word ptr esi[SPREG]
    mov  al, byte ptr esi[IYLREG]
    call PutByte
    jmp  @Exit

  @IY_AND_BYTE_Func:
    mov bx, word ptr esi[PCREG]
    call GetByte
    inc  word ptr esi[PCREG]
    and  byte ptr esi[AREG], al
    lahf
    and  byte ptr esi[FREG], $FF xor (H_FLAG or N_FLAG or S_FLAG or Z_FLAG or P_FLAG or C_FLAG)
    and  ah, S_FLAG or Z_FLAG or P_FLAG
    or   ah, H_FLAG
    mov  byte ptr esi[FREG], ah
    jmp  @Exit

  @IY_RST20_Func:
    dec  word ptr esi[SPREG]
    mov  bx, word ptr esi[SPREG]
    mov  al, byte ptr esi[PCHREG]
    call PutByte

    dec  word ptr esi[SPREG]
    mov  bx, word ptr esi[SPREG]
    mov  al, byte ptr esi[PCLREG]
    call PutByte

    mov word ptr esi[PCREG], $0020
    jmp  @Exit

  @IY_RET_PE_Func:
    test byte ptr esi[FREG], 00000100b
    jz   @RETPEFalse

    mov  bx, word ptr esi[SPREG]
    call GetByte
    mov  byte ptr esi[PCLREG], al
    inc  word ptr esi[SPREG]

    mov  bx, word ptr esi[SPREG]
    call GetByte
    mov  byte ptr esi[PCHREG], al
    inc  word ptr esi[SPREG]
    jmp  @Exit

  @RETPEFalse:
    jmp  @Exit

  @IY_LD_PC_HL_Func:
    mov  ax, word ptr esi[IYREG]
    mov  word ptr esi[PCREG], ax
    jmp  @Exit

  @IY_JP_PE_Func:
    test byte ptr esi[FREG], 00000100b
    jz   @JPPEFalse

    mov  bx, word ptr esi[PCREG]
    call GetByte
    xchg ah, al
    inc  bx
    call GetByte
    xchg ah, al
    mov  word ptr esi[PCREG], ax
    jmp  @Exit

  @JPPEFalse:
    inc  word ptr esi[PCREG]
    inc  word ptr esi[PCREG]
    jmp  @Exit

  @IY_EX_DE_HL_Func:
    mov ax, word ptr esi[DEREG]       { ax <- DE}
    mov bx, word ptr esi[IYREG]       { bx <- IY}
    mov word ptr esi[IYREG], ax       { IY <- ax }
    mov word ptr esi[DEREG], bx       { DE <- bx }
    jmp  @Exit

  @IY_CALL_PE_Func:
    test byte ptr esi[FREG], 00000100b
    jz   @CALLPEFalse

    mov  bx, word ptr esi[PCREG]
    call GetByte
    xchg ah, al
    inc  bx
    call GetByte
    xchg ah, al
    inc  word ptr esi[PCREG]
    inc  word ptr esi[PCREG]
    push ax
    dec  word ptr esi[SPREG]
    mov  bx, word ptr esi[SPREG]
    mov  al, byte ptr esi[PCHREG]
    call PutByte

    dec  word ptr esi[SPREG]
    mov  bx, word ptr esi[SPREG]
    mov  al, byte ptr esi[PCLREG]
    call PutByte
    pop  ax
    mov  word ptr esi[PCREG], ax
    jmp  @Exit

  @CALLPEFalse:
    inc  word ptr esi[PCREG]
    inc  word ptr esi[PCREG]
    jmp  @Exit

  @IY_PFX_ED_Func:
    call OpcodeFDED
    jmp  @Exit

  @IY_XOR_BYTE_Func:
    mov bx, word ptr esi[PCREG]
    call GetByte
    inc  word ptr esi[PCREG]
    xor  byte ptr esi[AREG], al
    lahf
    and  ah, 11101100b    {H N C a cero}
    mov  byte ptr esi[FREG], ah
    jmp  @Exit

  @IY_RST28_Func:
    dec  word ptr esi[SPREG]
    mov  bx, word ptr esi[SPREG]
    mov  al, byte ptr esi[PCHREG]
    call PutByte

    dec  word ptr esi[SPREG]
    mov  bx, word ptr esi[SPREG]
    mov  al, byte ptr esi[PCLREG]
    call PutByte

    mov word ptr esi[PCREG], $0028
    jmp  @Exit

  @IY_RET_P_Func:
    test byte ptr esi[FREG], 10000000b
    jnz  @RETPFalse

    mov  bx, word ptr esi[SPREG]
    call GetByte
    mov  byte ptr esi[PCLREG], al
    inc  word ptr esi[SPREG]

    mov  bx, word ptr esi[SPREG]
    call GetByte
    mov  byte ptr esi[PCHREG], al
    inc  word ptr esi[SPREG]
    jmp  @Exit

  @RETPFalse:
    jmp  @Exit

  @IY_POP_AF_Func:
    mov  bx, word ptr esi[SPREG]
    call GetByte
    mov  byte ptr esi[FREG], al
    inc  word ptr esi[SPREG]

    mov  bx, word ptr esi[SPREG]
    call GetByte
    mov  byte ptr esi[AREG], al
    inc  word ptr esi[SPREG]
    jmp  @Exit

  @IY_JP_P_Func:
    test byte ptr esi[FREG], 10000000b
    jnz  @JPPFalse

    mov  bx, word ptr esi[PCREG]
    call GetByte
    xchg ah, al
    inc  bx
    call GetByte
    xchg ah, al
    mov  word ptr esi[PCREG], ax
    jmp  @Exit

  @JPPFalse:
    inc  word ptr esi[PCREG]
    inc  word ptr esi[PCREG]
    jmp  @Exit

  @IY_DI_Func:
    mov  byte ptr esi[IFF1], $00
    mov  byte ptr esi[IFF2], $00
    jmp  @Exit

  @IY_CALL_P_Func:
    test byte ptr esi[FREG], 10000000b
    jnz  @CALLPFalse

    mov  bx, word ptr esi[PCREG]
    call GetByte
    xchg ah, al
    inc  bx
    call GetByte
    xchg ah, al
    inc  word ptr esi[PCREG]
    inc  word ptr esi[PCREG]
    push ax
    dec  word ptr esi[SPREG]
    mov  bx, word ptr esi[SPREG]
    mov  al, byte ptr esi[PCHREG]
    call PutByte

    dec  word ptr esi[SPREG]
    mov  bx, word ptr esi[SPREG]
    mov  al, byte ptr esi[PCLREG]
    call PutByte
    pop  ax
    mov  word ptr esi[PCREG], ax
    jmp  @Exit

  @CALLPFalse:
    inc  word ptr esi[PCREG]
    inc  word ptr esi[PCREG]
    jmp  @Exit

  @IY_PUSH_AF_Func:
    dec  word ptr esi[SPREG]
    mov  bx, word ptr esi[SPREG]
    mov  al, byte ptr esi[AREG]
    call PutByte

    dec  word ptr esi[SPREG]
    mov  bx, word ptr esi[SPREG]
    mov  al, byte ptr esi[FREG]
    call PutByte
    jmp  @Exit

  @IY_OR_BYTE_Func:
    mov bx, word ptr esi[PCREG]
    call GetByte
    inc  word ptr esi[PCREG]
    or   byte ptr esi[AREG], al
    lahf
    and  ah, 11101100b    {N H C a cero}
    mov  byte ptr esi[FREG], ah
    jmp  @Exit

  @IY_RST30_Func:
    dec  word ptr esi[SPREG]
    mov  bx, word ptr esi[SPREG]
    mov  al, byte ptr esi[PCHREG]
    call PutByte

    dec  word ptr esi[SPREG]
    mov  bx, word ptr esi[SPREG]
    mov  al, byte ptr esi[PCLREG]
    call PutByte

    mov word ptr esi[PCREG], $0030
    jmp  @Exit

  @IY_RET_M_Func:
    test byte ptr esi[FREG], 10000000b
    jz   @RETMFalse

    mov  bx, word ptr esi[SPREG]
    call GetByte
    mov  byte ptr esi[PCLREG], al
    inc  word ptr esi[SPREG]

    mov  bx, word ptr esi[SPREG]
    call GetByte
    mov  byte ptr esi[PCHREG], al
    inc  word ptr esi[SPREG]
    jmp  @Exit

  @RETMFalse:
    jmp  @Exit

  @IY_LD_SP_HL_Func:
    mov  ax, word ptr esi[IYREG]
    mov  word ptr esi[SPREG], ax
    jmp  @Exit

  @IY_JP_M_Func:
    test byte ptr esi[FREG], 10000000b
    jz   @JPMFalse

    mov  bx, word ptr esi[PCREG]
    call GetByte
    xchg ah, al
    inc  bx
    call GetByte
    xchg ah, al
    mov  word ptr esi[PCREG], ax
    jmp  @Exit

  @JPMFalse:
    inc  word ptr esi[PCREG]
    inc  word ptr esi[PCREG]
    jmp  @Exit

  @IY_EI_Func:
    cmp  byte ptr esi[IFF1], $00
    jne  @IFF1NotZero
    mov  byte ptr esi[IFF1], $01
    mov  byte ptr esi[IFF2], $01
    inc  byte ptr esi[RREG]
    call OpCode
    call EIInterrupt
    jmp  @ExitEI
  @IFF1NotZero:
    mov  byte ptr esi[IFF2], $01
  @ExitEI:
    jmp  @Exit

  @IY_CALL_M_Func:
    test byte ptr esi[FREG], 10000000b
    jz   @CALLMFalse

    mov  bx, word ptr esi[PCREG]
    call GetByte
    xchg ah, al
    inc  bx
    call GetByte
    xchg ah, al
    inc  word ptr esi[PCREG]
    inc  word ptr esi[PCREG]
    push ax
    dec  word ptr esi[SPREG]
    mov  bx, word ptr esi[SPREG]
    mov  al, byte ptr esi[PCHREG]
    call PutByte

    dec  word ptr esi[SPREG]
    mov  bx, word ptr esi[SPREG]
    mov  al, byte ptr esi[PCLREG]
    call PutByte
    pop  ax
    mov  word ptr esi[PCREG], ax
    jmp  @Exit

  @CALLMFalse:
    inc  word ptr esi[PCREG]
    inc  word ptr esi[PCREG]
    jmp  @Exit

  @IY_PFX_FD_Func:
    call OpcodeFD
    jmp  @Exit

  @IY_CP_BYTE_Func:
    mov bx, word ptr esi[PCREG]
    call GetByte
    inc  word ptr esi[PCREG]
    cmp byte ptr esi[AREG], al
    lahf
    jo   @CP_BYTEOverflow
    {;Sin overflow}
    and  ah,11111011b    {Overflow a 0}
    or   ah,00000010b    {N a 1}
    mov  byte ptr esi[FREG],ah
    jmp  @CP_BYTEExit
  @CP_BYTEOverflow:
    or   ah, 00000110b    {Overflow y N a 1}
    mov  byte ptr esi[FREG], ah
  @CP_BYTEExit:
    jmp  @Exit

  @IY_RST38_Func:
    dec  word ptr esi[SPREG]
    mov  bx, word ptr esi[SPREG]
    mov  al, byte ptr esi[PCHREG]
    call PutByte

    dec  word ptr esi[SPREG]
    mov  bx, word ptr esi[SPREG]
    mov  al, byte ptr esi[PCLREG]
    call PutByte

    mov word ptr esi[PCREG], $0038
    jmp  @Exit

  @Exit:
end;
